/*----------------------------------------------------------------------*\

	pmParse.c

	ParserMaker generated parser

\*----------------------------------------------------------------------*/

/* %%IMPORT */


#include "srcp.h"
#include "smScan.h"
#include "token.h"

#include "lmList.h"

#include "act.h"                /* ACT-nodes */
#include "adv.h"		/* ADV-node */
#include "alt.h"                /* ALT-nodes */
#include "atr.h"                /* ATR-nodes */
#include "chk.h"                /* CHK-nodes */
#include "cnt.h"		/* CNT-nodes */
#include "elm.h"                /* ELM-nodes */
#include "evt.h"                /* EVT-nodes */
#include "exp.h"                /* EXP-nodes */
#include "ext.h"                /* EXT-nodes */
#include "lim.h"		/* LIM-nodes */
#include "loc.h"                /* LOC-nodes */
#include "lst.h"		/* LST-nodes */
#include "msg.h"                /* MSG-nodes */
#include "nam.h"		/* NAM-nodes */
#include "obj.h"		/* OBJ-nodes */
#include "opt.h"		/* OPTIONS */
#include "res.h"                /* RES-nodes */
#include "rul.h"                /* RUL-nodes */
#include "sco.h"                /* SCORES */
#include "scr.h"                /* SCR-nodes */
#include "stm.h"		/* STM-nodes */
#include "stp.h"                /* STP-nodes */
#include "str.h"		/* STRINGS */
#include "stx.h"                /* STX-nodes */
#include "syn.h"                /* SYN-nodes */
#include "vrb.h"                /* VRB-nodes */
#include "whr.h"                /* WHR-nodes */
#include "wht.h"                /* WHT-nodes */


/* END %%IMPORT */

#include <string.h>
#include <setjmp.h>

#include "pmParse.h"

#define PMTRUE 1
#define PMFALSE 0
typedef unsigned char PmBoolean; /* For logical values */

/* System dependencies */

/* These datatypes should be defined to be unsigned integers of length 1, 2
 * and 4 bytes respectively.
 */
typedef unsigned char UByte1;
typedef unsigned short UByte2;
typedef unsigned int UByte4;

/* Token definition */
#include "alanCommon.h"

/* %%ATTRIBUTES - The semantic attributes for grammar symbols */
typedef struct pmGrammar {
    WhtNod *wht;
    WhrNod *whr;
    List *vrbs;
    VrbNod *vrb;
    int val;
    List *syns;
    SynNod *syn;
    List *stxs;
    StxNod *stx;
    char *str;
    List *stps;
    StpNod *stp;
    List *stms3;
    List *stms2;
    List *stms;
    StmNod *stm;
    Srcp srcp;
    int bits;
    Bool single;
    List *scrs;
    ScrNod *scr;
    List *ruls;
    RulNod *rul;
    List *ress;
    ResNod *res;
    QualKind qual;
    OpKind op;
    List *objs;
    ObjNod *obj;
    Bool not;
    List *nams2;
    List *nams;
    NamNod *nam;
    List *msgs;
    MsgNod *msg;
    Bool minus;
    List *locs;
    LocNod *loc;
    List *lims;
    LimNod *lim;
    List *exts;
    ExtNod *ext;
   ExpKind expkd;
    ExpNod *exp;
    List *evts;
    EvtNod *evt;
    List *elms;
    ElmNod *elm;
    List *cnts;
    CntNod *cnt;
    NamKind classkd;
    List *chks;
    ChkNod *chk;
    List *cases;
    List *atrs;
    AtrNod *atr;
    List *alts;
    AltNod *alt;
    AgrKind agr;
    List *acts;
    ActNod *act;
} pmGrammar;

/* END %%ATTRIBUTES */

/* Parser constants *\
\* ---------------- */
#define ERROR_ACT 0			/* Action - Error */
#define SHIFT_ACT 1			/* Action - Shift */
#define SHIFTRED_ACT 2		/* Action - Shift_Reduce */
#define REDUCE_ACT 3		/* Action - Reduce */
#define ACCEPT_ACT 4		/* Action - Accept */

#define ERR_SYM 0		/* Error token */
#define ENDMARK 1		/* End of file token code */

/* Recovery method *\
\* --------------- */
#define NONE_REC 0		/* No recovery found */
#define IN_REC 1		/* Insertion of symbol(s) */
#define DEL_REC 2		/* Deletion of symbol(s) */
#define REP_REC 3		/* Replacement of symbol(s) */
#define BAK_REC 4		/* Stack backup */
#define HALT_REC 5		/* System halted */

/* Error class *\
\* ----------- */
#define LEX_ERR 1		/* Non valid scanner symbol found */
#define SYN_ERR 2		/* Normal syntax error */
#define OFLW_ERR 3		/* Parse stack overflow */
#define TAB_ERR 4		/* Parse table error */
	   
/* Error severity *\
\* -------------- */
#define WAR_SEV 1		/* Warnings */
#define ERR_SEV 2		/* Repairable error */
#define FAT_SEV 3		/* Fatal error */
#define SYS_SEV 4		/* System & limit error */

/* Parser constants *\
\* ---------------- */
#define SccMax 104		/* Max scanner code value */
#define TermMin 1		/* Minimum terminal number */
#define Terms 104		/* Number of terminals in grammar */
#define StateMin 1		/* Minimum state number */
#define States 285		/* Number of states */
#define ProdMin 1		/* Minimum production number */
#define Prods 306		/* Number of productions */
#define PmStkMax 64		/* Parse stack size */
#define	PmLaMax 5		/* Look-ahead length */
#define	PmCost 5		/* Shifting cost */

/* Types *\
\* ----- */
typedef unsigned char TermSet[(Terms + TermMin + 7) >> 3]; /* Terminal set */
typedef UByte2 ParseStack[PmStkMax]; /* Parse stack */

/* Terminal table *\
\* -------------- */

typedef struct {
    UByte1 tsym;		/* Normal continuation */
    UByte1 ssym;		/* Separator continuation */
} ContRec;

typedef struct {
    ContRec cont[285];		/* Continuation function */
    TermSet sepa;		/* Separator symbols */
    TermSet fiduc;		/* Fiducial symbols */
    TermSet skip;		/* Symbols to skip */
} RecTab;

typedef struct  {
    UByte2 act[11183];		/* Action table */
    UByte2 actCheck[11188];	/* Row Displacement Check Vector*/
    UByte2 actRix[285];		/* Action row mapping */
    RecTab recover;		/* Error recovery info */
} TermTab;

static TermTab act = {
{4,0,1273,1987,1987,1987,1755,1987,1987,1546,1987,1987,1987,1987,1987,1987
,1987,1987,1987,1987,242,1987,105,169,1987,1987,1987,1987,1987,579,1987
,1987,1619,1987,1987,1987,1987,1987,810,1385,105,705,579,251,1987,1987,1987
,1987,579,593,1987,2250,1995,1987,1987,1987,1987,937,1578,105,105,579,1099
,1217,1987,1866,1353,193,1987,938,105,1369,963,185,2227,729,1987,1987,1987
,1987,1099,1809,1987,1131,274,946,954,1987,1987,515,251,1987,1545,1633,1987
,1987,1987,1987,1987,1131,1131,1987,2243,713,1131,2010,105,1889,1099,681
,1627,1131,1131,1619,1131,1131,1131,89,641,673,1131,515,105,1131,1689,1131
,1458,353,369,1131,593,2018,546,2234,1131,337,361,545,1273,1273,1257,905
,1937,1131,538,1691,441,1131,1131,1777,393,1833,1953,1737,1131,1689,1131
,1131,409,425,465,489,1131,777,1785,1131,266,1131,1131,385,377,1131,1131
,1131,475,1667,73,505,569,617,1131,1131,1131,793,659,1131,1529,691,643,691
,1906,475,305,1667,713,475,819,659,105,234,1481,643,1481,659,475,475,691
,643,89,641,673,475,1474,1817,475,889,475,1458,353,369,1505,475,643,643
,105,475,337,361,545,595,1554,475,475,475,475,643,643,441,914,475,193,393
,1617,475,475,1610,185,475,1617,409,425,465,489,475,1505,1505,475,105,475
,475,385,377,475,475,475,475,475,73,505,569,617,475,475,1746,793,1803,2163
,1803,2010,1803,2058,1466,2042,2050,2066,2163,2163,1803,1995,938,2163,1803
,209,1803,19,1417,2163,2163,2163,2163,2163,19,2170,1803,2018,946,954,1803
,1803,1803,1562,19,19,57,1570,1449,1803,1803,1803,1803,1457,1913,1803,19
,19,1803,1803,1803,2163,273,634,1146,761,769,1650,225,1803,2249,19,19,1803
,506,529,506,801,19,19,1482,1803,1803,1803,1803,19,498,2163,498,530,2001
,530,1803,1803,2009,1490,2163,1090,1498,1803,1803,1803,1803,2163,2282,522
,1803,522,833,233,1706,2057,193,1506,2250,1393,1282,1393,185,1185,1586,2378
,865,2105,713,2370,1514,2129,1522,1594,2153,1530,169,2177,417,2442,1538
,306,89,641,673,2426,201,217,1673,1602,2418,1561,1569,1577,2010,2225,786
,1202,433,2346,337,361,545,657,1305,1978,961,58,2402,2243,66,441,1930,2386
,0,1601,0,1962,0,0,2018,2450,0,409,425,465,489,2410,257,339,2394,0,2306
,2290,1593,1585,2434,2298,2354,1970,0,73,505,569,617,2362,339,0,793,713
,339,0,0,0,0,0,0,0,0,0,339,0,0,89,641,673,339,0,0,339,0,339,1458,353,369
,0,339,0,0,0,339,337,361,545,0,0,339,339,339,339,0,0,441,0,339,0,393,0,339
,339,0,0,339,0,409,425,465,489,339,0,0,339,0,339,339,385,377,339,339,339
,339,339,73,505,569,617,339,339,1875,793,0,0,1875,0,1875,1875,1875,1875
,1875,1875,0,1875,1875,0,0,1459,0,0,1875,1875,1875,1875,1875,1459,1875,1875
,0,1875,1875,1459,1459,1459,0,0,0,0,1459,0,1459,1459,1459,1875,1459,1019
,0,193,0,1459,1459,1459,1875,185,0,0,0,1019,0,0,1459,1019,1019,0,1459,0
,0,0,0,1019,1019,1019,1459,1459,1459,1459,0,1065,1875,0,0,0,0,1459,1459
,2010,0,1875,0,0,1459,1459,1459,1459,1875,1739,0,1459,0,1739,0,1739,1739
,1739,1739,1739,0,0,1739,1739,0,2018,713,0,0,1739,1739,1739,1739,1739,1739
,1739,0,0,1739,1739,89,641,673,0,0,1019,0,0,0,1458,353,369,1739,0,731,0
,193,0,337,361,545,1739,185,0,0,0,731,0,0,441,731,731,0,393,0,0,0,0,731
,731,731,409,425,465,489,0,0,1739,0,0,0,0,385,377,2010,0,1739,0,0,73,505
,569,617,1739,1731,0,793,0,1731,0,1731,1731,1731,1731,1731,0,0,1731,1731
,0,2018,713,0,0,1731,1731,1731,1731,1731,1731,1731,0,0,1731,1731,89,641
,673,0,0,731,0,0,0,1458,353,369,1731,0,0,0,0,0,337,361,545,1731,851,0,0
,0,0,0,0,441,0,0,0,393,851,0,0,0,851,851,0,409,425,465,489,0,851,1731,0
,0,0,0,385,377,0,0,1731,0,0,73,505,569,617,1731,979,0,793,0,713,0,0,0,0
,0,0,0,979,0,0,0,979,979,89,641,673,0,0,0,979,979,979,1458,353,369,0,851
,0,0,979,0,337,361,545,0,851,851,0,2082,851,0,0,441,0,0,0,393,2114,2122
,0,979,0,193,0,409,425,465,489,185,2074,2090,2098,2106,0,0,385,377,0,979
,0,0,0,73,505,569,617,987,979,979,793,713,979,0,0,0,0,0,0,987,0,2010,0,987
,987,89,641,673,0,0,0,987,987,987,1458,353,369,0,0,0,0,987,0,337,361,545
,0,2018,0,0,0,0,0,0,441,0,289,0,393,0,0,0,987,281,0,0,409,425,465,489,0
,0,0,0,0,0,0,385,377,2282,987,0,0,0,73,505,569,617,0,987,987,793,0,987,0
,1051,1051,0,0,0,2370,0,1051,0,0,0,0,1051,0,0,2442,1051,1051,0,0,0,2426
,0,0,1051,1051,1051,0,2314,2322,1307,0,1051,0,0,2346,0,0,0,1051,0,0,1307
,0,2402,0,1307,1307,0,2386,0,0,0,0,1307,1051,0,2450,0,2282,0,0,0,2410,2129
,1051,2394,0,2306,2290,2338,2330,2434,1051,2354,1107,2378,1633,0,0,2370
,2362,1051,1051,1201,1307,1051,1107,1001,0,2442,1107,1107,0,1113,2241,2426
,0,0,1107,0,2418,0,2314,2322,1107,1017,1281,0,0,2346,0,1307,0,0,0,1307,0
,0,2402,0,1161,953,1929,2386,0,0,0,1081,1233,1107,0,2450,1107,0,2025,0,0
,2410,713,0,2394,0,2306,2290,2338,2330,2434,1107,2354,0,0,0,89,641,673,2362
,1107,1107,1355,0,1107,1458,353,369,0,1355,0,0,0,0,337,361,545,0,0,1355
,1355,1355,0,0,0,441,0,0,0,393,0,1355,1355,0,0,0,0,409,425,465,489,0,0,0
,0,0,1355,1355,385,377,0,938,0,1355,1355,73,505,569,617,2282,1355,0,793
,2049,233,0,0,946,954,2250,0,0,0,0,0,1633,2378,0,0,0,2370,0,0,0,0,0,0,0
,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,2089,0,0,0,2346
,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,1833
,0,0,0,1689,2410,257,0,2394,938,2306,2290,2338,2330,2434,2298,2354,1970
,0,2282,0,1665,0,2362,233,946,954,0,0,2250,0,0,0,1633,1481,1721,2378,0,0
,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314
,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0
,1962,0,0,0,2450,0,0,1689,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434
,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0
,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314
,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0
,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298
,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370
,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0
,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0
,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354
,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0
,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0
,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970
,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0
,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0
,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450
,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282
,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0
,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0
,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0
,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0
,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0
,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0
,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0
,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0
,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442
,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0
,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410
,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362
,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0
,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978
,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257
,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233
,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0
,0,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0
,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0
,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0
,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0
,2426,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0
,2402,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394
,0,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0
,2250,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426
,201,217,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402
,2243,0,0,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0
,2306,2290,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250
,0,0,0,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217
,0,0,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0
,1930,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0
,0,0,0,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0
,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930
,2386,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338
,2330,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0
,2378,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418
,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386
,0,1890,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330
,2434,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378
,0,0,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874
,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890
,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434
,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,1227,2378,0
,0,0,2370,0,0,0,0,0,0,1227,0,0,2442,1227,1227,0,0,0,2426,201,217,1227,0
,2418,1874,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930
,2386,0,1890,0,1962,0,1227,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,1970,1163,0,0,0,713,2362,1227,0,0,0,1227,0,1163
,0,0,0,1163,1163,89,641,673,0,0,0,1163,0,0,1458,353,369,1163,0,0,0,0,0,337
,361,545,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,1163,0,0,0,409,425,465,489
,0,2282,0,0,0,0,233,385,377,0,1163,2250,0,0,73,505,569,617,2378,1163,1163
,793,2370,1163,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874
,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890
,0,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434
,2298,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0
,0,2370,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314
,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0
,1962,0,0,0,2450,0,0,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298
,2354,1970,0,2282,0,0,0,2362,233,0,0,0,0,2250,0,0,0,0,0,0,2378,0,0,0,2370
,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,201,217,0,0,2418,1874,2314,2322,0
,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,2243,0,0,1930,2386,0,1890,0,1962,0
,0,0,2450,0,2282,0,0,0,2410,257,0,2394,0,2306,2290,2338,2330,2434,2298,2354
,1970,2378,0,0,0,2370,2362,0,0,0,0,0,0,1001,0,2442,0,0,0,0,0,2426,0,0,227
,0,2418,0,2314,2322,0,227,0,0,0,2346,0,0,0,0,0,227,227,227,2402,0,0,0,0
,2386,0,0,0,227,227,0,0,2450,0,0,0,0,0,2410,0,0,2394,0,227,227,2338,2330
,2434,2298,2354,227,227,0,0,1179,0,2362,227,713,0,0,0,0,0,0,0,1179,0,0,0
,1179,1179,89,641,673,0,0,0,1179,0,0,1458,353,369,0,0,0,0,0,0,337,361,545
,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,1179,0,0,0,409,425,465,489,0,2282,0
,0,0,0,0,385,377,0,1179,0,0,0,73,505,569,617,2378,1179,1179,793,2370,1179
,0,0,0,0,0,0,1001,0,2442,0,0,0,0,0,2426,0,0,219,0,2418,0,2314,2322,0,219
,0,0,0,2346,0,0,0,0,0,219,219,219,2402,0,0,0,0,2386,0,0,0,219,219,0,0,2450
,0,0,0,0,2282,2410,0,0,2394,0,219,219,2338,2330,2434,2298,2354,219,219,0
,0,2378,0,2362,219,2370,0,0,0,0,0,0,0,1001,0,2442,0,0,0,0,0,2426,0,0,203
,0,2418,0,2314,2322,0,203,0,0,0,2346,0,0,0,0,0,203,203,203,2402,0,0,0,0
,2386,0,0,0,203,203,0,0,2450,0,0,0,0,2282,2410,0,0,2394,0,203,203,2338,2330
,2434,2298,2354,203,203,0,0,2378,0,2362,203,2370,0,0,0,0,0,0,0,1001,0,2442
,0,0,0,0,0,2426,0,0,211,0,2418,0,2314,2322,0,211,0,0,0,2346,0,0,0,0,0,211
,211,211,2402,0,0,0,0,2386,0,0,0,211,211,0,0,2450,0,0,0,0,451,2410,0,0,2394
,0,211,211,2338,2330,2434,2298,2354,211,211,0,0,451,0,2362,211,451,0,0,0
,0,0,0,0,0,1337,451,0,0,0,0,0,451,0,0,451,0,451,0,451,451,0,451,0,0,0,451
,0,0,0,0,0,451,451,451,451,0,0,0,0,451,0,0,0,451,451,0,0,451,0,0,0,0,2282
,451,0,0,451,0,451,451,451,451,451,451,451,451,451,0,0,2378,0,451,451,2370
,0,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,283,0,2418,0,2314,2322,0,283
,0,0,0,2346,0,0,0,0,0,283,283,283,2402,0,0,0,0,2386,0,0,0,283,283,0,0,2450
,0,0,0,0,0,2410,0,0,2394,0,283,283,2338,2330,2434,2298,2354,283,283,0,0
,707,0,2362,283,713,0,0,0,0,0,0,0,707,0,0,0,707,707,89,641,673,0,0,0,707
,707,707,1458,353,369,0,707,0,1035,1035,0,337,361,545,0,1035,0,0,0,0,1035
,0,441,0,1035,1035,393,2282,0,0,0,0,1035,0,409,425,465,489,0,0,1035,0,0
,0,2378,385,377,1035,2370,0,0,0,73,505,569,617,0,0,2442,793,0,707,0,0,2426
,0,0,347,0,2418,0,2314,2322,1035,347,0,0,0,2346,0,0,1035,0,0,347,347,347
,2402,0,0,1035,1035,2386,0,1035,0,347,347,0,0,2450,0,0,0,0,0,2410,0,0,2394
,0,347,347,2338,2330,2434,2298,2354,347,347,0,0,995,0,2362,347,713,0,0,0
,0,0,0,0,995,0,0,0,995,995,89,641,673,0,0,0,995,0,0,1458,353,369,0,0,0,0
,0,0,337,361,545,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,0,0,0,0,409,425,465
,489,0,0,0,0,0,0,0,385,377,0,995,0,0,0,73,505,569,617,1003,995,995,793,713
,995,0,0,0,0,0,0,1003,0,0,0,1003,1003,89,641,673,0,0,0,1003,0,0,1458,353
,369,0,0,0,0,0,0,337,361,545,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,0,0,0,0
,409,425,465,489,0,0,0,0,0,0,0,385,377,0,1003,0,0,0,73,505,569,617,1011
,1003,1003,793,713,1003,0,0,0,0,0,0,1011,0,0,0,1011,1011,89,641,673,0,0
,0,1011,0,0,1458,353,369,0,0,0,0,0,0,337,361,545,0,0,0,0,0,0,0,0,441,0,0
,0,393,0,0,0,0,0,0,0,409,425,465,489,0,0,0,0,0,0,0,385,377,0,1011,0,0,0
,73,505,569,617,1331,1011,1011,793,713,1011,0,0,0,0,0,0,1331,0,0,0,1331
,1331,89,641,673,0,0,0,1331,0,0,1458,353,369,0,0,0,0,1331,0,337,361,545
,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,1331,0,0,0,409,425,465,489,0,0,0,0
,0,0,0,385,377,0,0,0,0,0,73,505,569,617,1339,1331,0,793,713,1331,0,0,0,0
,0,0,1339,0,0,0,1339,1339,89,641,673,0,0,0,1339,0,0,1458,353,369,0,0,0,1099
,1339,0,337,361,545,0,0,0,0,0,0,1099,0,441,0,1099,1099,393,2282,0,0,1339
,0,1099,0,409,425,465,489,1099,0,0,0,0,0,2378,385,377,0,2370,0,0,0,73,505
,569,617,0,1339,2442,793,0,1339,0,1099,2426,1889,1099,315,0,2418,0,2314
,2322,0,315,0,0,0,2346,0,0,1099,0,0,315,315,315,2402,0,0,1099,1099,2386
,0,1099,0,315,315,0,0,2450,0,0,0,0,0,2410,0,0,2394,0,315,315,2338,2330,2434
,2298,2354,315,315,0,0,1347,0,2362,315,713,0,0,0,0,0,0,0,1347,0,0,0,1347
,1347,89,641,673,0,0,1633,1347,0,0,1458,353,369,1201,0,0,0,1347,0,337,361
,545,0,1113,2241,41,0,0,0,0,441,0,0,0,393,1017,1281,0,1347,0,0,0,409,425
,465,489,0,0,0,0,1161,953,0,385,377,2282,0,1081,1233,0,73,505,569,617,2025
,1347,0,793,0,1347,0,899,2378,0,0,0,2370,0,0,0,0,0,0,899,1001,0,2442,899
,899,0,0,0,2426,0,0,899,0,2418,0,2314,2322,0,0,0,0,1171,2346,0,0,0,0,0,0
,0,0,2402,0,1171,0,0,2386,1171,1171,0,0,0,0,0,2450,1171,2282,0,0,0,2410
,1857,0,2394,0,2306,2290,2338,2330,2434,899,2354,1259,2378,0,0,0,2370,2362
,899,899,0,0,899,1259,1001,1171,2442,1259,1259,0,0,0,2426,0,0,1259,0,2418
,0,2314,2322,0,0,1171,0,0,2346,0,0,0,0,0,1171,1171,0,2402,1171,0,0,0,2386
,0,0,0,0,0,1259,0,2450,2282,0,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330
,2434,2298,2354,2378,0,0,0,2370,0,2362,1259,0,0,0,1259,0,0,2442,0,0,0,0
,0,2426,0,0,27,0,2418,0,2314,2322,0,27,0,0,0,2346,0,0,0,0,0,27,27,0,2402
,0,0,0,0,2386,0,0,0,27,27,0,0,2450,0,0,0,0,2282,2410,0,0,2394,0,27,27,2338
,2330,2434,2298,2354,27,27,0,763,2378,0,2362,27,2370,0,0,0,0,0,0,763,1001
,0,2442,763,763,0,0,0,2426,0,0,763,763,763,0,2314,2322,0,0,0,0,0,2346,0
,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,0,0,2410,0,0,2394
,0,2306,2290,2338,2330,2434,2298,2354,1779,0,0,0,1779,0,2362,0,0,0,0,763
,1779,0,1995,193,1779,0,1779,0,0,185,0,0,0,0,1995,0,121,0,1995,1995,1779
,1779,1779,0,0,0,1995,0,0,1779,1779,1779,1779,0,1995,1779,0,0,1779,1779
,1779,2010,0,0,0,0,0,0,0,1779,0,0,0,1779,0,0,0,1995,0,0,0,1779,1779,1779
,1779,0,0,2018,0,0,0,1771,1779,1779,0,1771,0,0,0,1779,1779,1779,1779,1771
,1995,0,1779,1771,1995,1771,0,0,0,0,0,0,0,0,0,121,0,0,0,1771,1771,1771,0
,0,0,0,0,0,1771,1771,1771,1771,0,0,1771,0,0,1771,1771,1771,0,0,0,0,0,0,0
,0,1771,0,0,0,1771,0,0,0,0,0,0,0,1771,1771,1771,1771,0,0,0,0,0,0,0,1771
,1771,0,0,0,0,0,1771,1771,1771,1771,403,0,403,1771,0,403,0,426,434,0,0,0
,0,0,0,0,0,403,0,0,0,403,0,0,0,0,2163,0,0,0,2058,403,2042,2050,2066,2163
,2163,403,0,938,2163,0,403,0,403,403,2163,2163,2163,2163,2163,403,2170,0
,0,946,954,0,0,0,403,0,403,0,0,403,0,0,0,841,0,0,0,403,0,0,0,0,2163,403
,0,0,403,0,403,403,403,403,403,403,403,411,0,411,0,0,411,403,411,411,0,0
,0,0,2163,0,0,0,411,0,0,0,411,2163,0,0,0,0,0,0,2163,0,411,0,0,0,0,0,411
,0,0,0,0,411,0,411,411,0,0,0,0,0,411,0,0,0,0,0,0,0,0,411,0,411,0,0,411,0
,0,0,0,0,0,0,411,0,0,0,0,0,411,0,0,411,0,411,411,411,411,411,411,411,713
,0,0,0,0,0,411,0,683,0,683,0,0,0,89,641,673,0,0,0,0,683,0,1458,353,369,0
,683,0,0,0,0,337,361,545,0,0,0,0,0,0,0,0,441,0,0,0,393,0,0,0,0,0,0,0,409
,425,465,489,0,0,0,0,0,0,0,385,377,0,0,0,0,0,73,505,569,617,1514,2331,0
,793,0,2331,0,2331,2331,2331,2331,2331,2331,0,2331,2331,0,0,0,0,2331,2331
,2331,2331,2331,2331,0,2331,2331,0,2331,2331,0,0,0,0,0,0,0,0,1522,2339,0
,0,2331,2339,0,2339,2339,2339,2339,2339,2339,2331,2339,2339,0,0,0,0,2339
,2339,2339,2339,2339,2339,0,2339,2339,0,2339,2339,0,0,0,0,0,0,0,2331,0,0
,0,0,2339,0,0,0,2331,0,0,0,0,2339,0,2331,0,0,0,2227,1891,0,0,0,1891,0,1891
,1891,1891,1891,1891,1891,0,1891,1891,0,0,0,0,2339,1891,1891,1891,1891,1891
,0,1891,1891,2339,1891,1891,0,0,0,0,2339,0,0,0,0,0,713,0,1891,0,0,0,0,0
,1659,0,0,1891,0,0,89,641,673,2234,0,0,0,0,0,1458,353,369,1659,0,0,0,0,0
,337,361,545,0,0,1891,0,0,0,0,0,441,0,0,1891,393,921,0,0,0,0,1891,0,409
,425,465,489,0,0,0,0,713,0,0,385,377,0,0,0,651,0,73,505,569,617,89,641,673
,793,0,0,0,651,0,1458,353,369,0,651,0,0,0,0,337,361,545,0,713,0,0,0,0,0
,0,441,1675,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458,353,369,1675
,0,0,0,385,377,337,361,545,0,2131,73,505,569,617,0,0,441,793,0,0,393,1675
,0,2131,2131,2131,0,0,409,425,465,489,2131,2131,2131,0,0,0,0,385,377,2131
,2131,2131,0,2154,73,505,569,617,0,0,2131,793,2146,0,2131,0,0,0,0,0,0,0
,2131,2131,2131,2131,0,0,0,2138,713,0,0,2131,2131,0,0,0,1683,0,2131,2131
,2131,2131,89,641,673,2131,0,0,0,0,0,1458,353,369,1683,0,0,0,0,0,337,361
,545,0,0,0,0,0,0,0,0,441,0,0,0,393,1683,0,0,0,0,0,0,409,425,465,489,0,0
,0,0,0,0,0,385,377,0,0,0,0,0,73,505,569,617,1490,2315,0,793,0,2315,0,2315
,2315,2315,2315,2315,2315,0,2315,2315,0,0,0,0,2315,2315,2315,2315,2315,2315
,0,2315,2315,0,2315,2315,0,0,0,0,0,0,0,0,1506,2323,0,0,2315,2323,0,2323
,2323,2323,2323,2323,2323,2315,2323,2323,0,0,0,0,2323,2323,2323,2323,2323
,2323,0,2323,2323,2282,2323,2323,0,0,0,0,0,0,0,2315,0,0,0,0,2323,0,2378
,0,2315,0,2370,1155,0,2323,0,2315,0,0,0,0,2442,0,0,1155,0,0,2426,1155,1155
,0,0,2418,0,2314,2322,1155,0,0,0,2323,2346,1155,0,0,0,0,1978,0,2323,2402
,0,0,0,0,2386,2323,0,0,1962,0,0,0,2450,0,2282,0,1155,0,2410,1873,0,2394
,0,2306,2290,2338,2330,2434,2298,2354,1970,2378,0,0,1155,2370,2362,0,0,0
,0,0,0,1155,1155,2442,0,1155,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0
,0,2346,0,0,0,0,0,1978,0,0,2402,0,0,0,0,2386,0,0,0,1962,0,0,0,2450,0,2282
,0,442,0,2410,1401,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,2378
,0,0,0,2370,2362,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314
,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,1321,0,0,2386,0,0,0,0,0,0,0
,2450,2282,0,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378
,0,0,0,2370,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314
,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,0,0,0,0,2386,0,0,0,1962,0,0
,0,2450,0,0,0,0,713,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970
,89,641,673,0,0,2362,0,0,0,1458,353,369,0,0,0,0,0,2169,337,361,545,0,0,0
,0,0,0,0,0,441,0,2145,0,393,2282,0,0,0,0,0,0,409,425,465,489,0,0,0,0,0,0
,2378,385,377,0,2370,0,0,0,73,505,569,617,0,0,2442,793,0,0,0,0,2426,0,0
,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,0,0,0,0,2386
,0,0,0,1962,0,0,0,2450,0,2282,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330
,2434,2298,2354,1970,2378,0,0,0,2370,2362,0,0,0,0,0,0,0,0,2442,0,0,0,0,0
,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0,0,2402,0
,0,0,0,2386,0,0,0,1962,0,0,0,2450,0,2282,0,0,0,2410,0,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,1970,2378,0,0,0,2370,2362,0,0,0,0,0,0,0,0,2442
,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,1978,0
,0,2402,0,0,0,0,2386,0,0,0,1962,0,0,0,2450,0,2282,0,0,0,2410,0,0,2394,0
,2306,2290,2338,2330,2434,2298,2354,1970,2378,0,0,0,2370,2362,0,0,0,0,0
,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0
,0,0,1978,0,0,2402,0,0,0,0,2386,0,0,0,1962,0,0,0,2450,0,2282,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,2378,0,0,0,2370,2362
,0,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0
,2346,0,0,0,0,0,1978,0,0,2402,0,0,0,0,2386,0,0,0,1962,0,0,0,2450,0,0,0,0
,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,1970,713,0,0,0,0,2362
,0,0,1699,0,0,0,0,0,89,641,673,1371,0,0,0,0,0,1458,353,369,0,0,0,0,0,0,337
,361,545,0,0,0,713,0,0,0,0,441,0,0,0,393,0,0,0,0,89,641,673,409,425,465
,489,0,0,1458,353,369,0,0,385,377,0,0,337,361,545,73,505,569,617,105,0,0
,793,441,0,713,0,393,0,0,0,0,0,0,0,409,425,465,489,89,641,673,0,0,0,0,385
,377,1458,353,369,0,0,73,505,569,617,337,361,545,793,0,0,0,0,0,0,0,441,0
,0,0,393,2282,0,0,0,0,0,0,409,425,465,489,0,0,0,0,0,0,2378,385,377,0,2370
,0,0,0,73,505,569,617,1001,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322
,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,1929,2386,0,0,0,0,0,0,0,2450
,0,0,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,713,0,0,0
,0,0,2362,0,2217,0,0,0,0,0,89,641,673,1379,0,0,0,0,0,1458,353,369,0,0,0
,0,0,0,337,361,545,0,0,0,713,0,0,0,0,441,0,0,0,393,0,0,0,0,89,641,673,409
,425,465,489,0,0,1458,353,369,0,0,385,377,0,0,337,361,545,73,505,569,617
,0,0,0,793,441,0,0,0,393,2282,0,50,0,0,0,0,409,425,465,489,0,0,0,0,0,0,2378
,385,377,0,2370,0,0,0,73,505,569,617,0,0,2442,793,0,0,0,0,2426,0,0,0,0,2418
,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,2281,0,0,0,2386,0,0,0,0
,0,0,0,2450,0,0,0,713,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354
,89,641,673,0,0,0,2362,0,0,1458,353,369,0,0,0,0,0,0,337,361,545,0,713,0
,0,0,0,0,0,441,0,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458,353,369
,0,0,0,0,385,377,337,361,545,0,0,73,505,569,617,0,0,441,793,0,0,393,2282
,0,2179,0,0,0,0,409,425,465,489,0,0,0,0,0,0,2378,385,377,0,2370,0,0,0,73
,505,569,617,0,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0
,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,0,2163,0,0,0,2058,2362,2042
,2050,2066,2163,2163,2282,0,938,2163,0,0,0,0,0,2163,2163,2163,2163,2163
,825,2170,0,2378,946,954,0,2370,0,0,0,0,0,0,0,1001,0,2442,841,0,0,0,0,2426
,0,0,0,2163,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0
,2386,0,2163,0,0,0,0,0,2450,2282,0,2163,0,0,2410,0,0,2394,2163,2306,2290
,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0,0,0,0,0,1001,0,2442,0
,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402
,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,2282,0,0,0,2410,1401,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,0,2378,0,0,0,2370,2362,0,0,0,0,0,0,0,0,2442,0
,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402
,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,2179,0,0,2410,0,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0,0,0,0,0,0,0,2442,0,0
,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402
,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,2179,0,0,2410,0,0,2394,0,2306,2290
,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0,0,0,0,0,0,0,2442,0,0
,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402
,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,713,0,2410,0,0,2394,0,2306,2290,2338
,2330,2434,2298,2354,89,641,673,0,0,0,2362,0,0,1458,353,369,0,0,0,0,0,0
,337,361,545,0,713,0,0,0,0,0,0,441,0,0,0,393,0,0,89,641,673,0,0,409,425
,465,489,1458,353,369,0,0,0,0,385,377,337,361,545,0,713,73,505,569,617,0
,0,441,793,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458,353,369,0,0,0
,0,385,377,337,361,545,0,0,73,505,569,617,0,0,441,793,0,0,393,2282,0,0,0
,0,0,0,409,425,465,489,0,0,0,0,0,0,2378,385,377,0,2370,0,0,0,73,505,569
,617,0,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0
,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,0,0,2410,713,0
,2394,0,2306,2290,2338,2330,2434,2298,2354,0,0,0,89,641,673,2362,0,0,0,1025
,0,1458,353,369,0,0,0,1995,193,0,337,361,545,0,185,0,0,0,0,1995,0,441,0
,1995,1995,393,2282,0,0,0,0,1995,0,409,425,465,489,0,0,1065,0,0,0,2378,385
,377,2010,2370,0,0,0,73,505,569,617,1001,0,2442,793,0,0,0,0,2426,0,0,0,0
,2418,0,2314,2322,2018,0,0,0,0,2346,0,0,1995,0,0,0,0,0,2402,0,0,1995,1995
,2386,0,1995,0,0,0,0,0,2450,0,0,0,713,0,2410,0,0,2394,0,2306,2290,2338,2330
,2434,2298,2354,89,641,673,0,0,0,2362,0,0,1458,353,369,0,0,0,0,0,0,337,361
,545,0,713,0,0,0,0,0,0,441,0,0,0,393,0,0,89,641,673,0,0,409,425,465,489
,1458,353,369,0,0,0,0,385,377,337,361,545,0,713,73,505,569,617,0,0,441,793
,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458,353,369,0,0,0,0,385,377
,337,361,545,0,0,73,505,569,617,0,0,441,793,0,0,393,2282,0,2179,0,0,0,0
,409,425,465,489,0,0,0,0,0,0,2378,385,377,0,2370,0,0,0,73,505,569,617,0
,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0
,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,713,0,2410,0,0,2394
,0,2306,2290,2338,2330,2434,2298,2354,89,641,673,0,0,0,2362,0,0,1458,353
,369,0,0,0,1995,193,0,337,361,545,0,185,0,0,0,0,1995,0,441,0,1995,1995,393
,2282,0,0,0,0,1995,0,409,425,465,489,0,0,1995,0,0,0,2378,385,377,2010,2370
,0,0,0,73,505,569,617,0,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322
,2018,0,0,0,0,2346,0,0,1995,0,0,0,0,0,2402,0,0,1995,1995,2386,0,1995,0,0
,0,0,0,2450,2282,0,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354
,2378,0,0,0,2370,0,2362,0,0,0,1089,0,1001,0,2442,0,0,0,0,0,2426,0,0,0,0
,2418,0,2314,2322,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0
,0,0,0,0,2450,0,0,0,713,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298
,2354,89,641,673,0,0,0,2362,0,0,1458,353,369,0,0,0,1035,1035,0,337,361,545
,0,1035,0,0,0,0,1035,0,441,0,1035,1035,393,2282,0,2179,0,0,1035,0,409,425
,465,489,0,0,1035,0,0,0,2378,385,377,1035,2370,0,0,0,73,505,569,617,0,0
,2442,793,0,0,0,1035,2426,0,0,0,0,2418,0,2314,2322,1035,0,0,0,0,2346,0,0
,0,0,0,0,0,0,2402,0,0,1035,0,2386,0,1035,0,0,0,0,0,2450,2282,0,2179,0,0
,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362
,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346
,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0
,0,0,0,0,1001,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346
,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0
,0,0,0,0,1001,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346
,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370,0,2362,0
,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346
,0,0,0,0,0,0,0,0,2402,2266,0,0,0,2386,0,0,0,0,0,0,0,2450,2163,0,0,0,0,2410
,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2163,0,0,0,2163,0,2362,0
,0,0,0,0,2170,0,2163,0,0,0,0,0,2163,0,0,0,0,2163,0,2163,2163,0,0,0,0,0,2163
,0,0,0,0,0,0,0,0,2163,0,0,0,0,2163,0,0,0,0,0,0,0,2163,2282,0,0,0,0,2163
,0,0,2163,0,2163,2163,2163,2163,2163,2163,2163,2378,0,0,0,2370,0,2163,0
,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0,0,0,2346
,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,0,0,2410,713
,0,2394,0,2306,2290,2338,2330,2434,2298,2354,0,0,0,89,641,673,2362,0,0,0
,1121,0,1458,353,369,0,0,0,1995,193,0,337,361,545,0,185,0,0,0,0,1995,0,441
,0,1995,1995,393,2282,0,0,0,0,1995,0,409,425,465,489,0,0,1065,0,0,0,2378
,385,377,2010,2370,0,0,0,73,505,569,617,1001,0,2442,793,0,0,0,1995,2426
,0,0,0,0,2418,0,2314,2322,2018,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,1995
,0,2386,0,1995,0,0,0,0,0,2450,0,0,0,713,0,2410,0,0,2394,0,2306,2290,2338
,2330,2434,2298,2354,89,641,673,0,0,0,2362,0,0,1458,353,369,0,0,0,0,0,0
,337,361,545,0,713,0,0,0,0,0,0,441,0,0,0,393,0,0,89,641,673,0,0,409,425
,465,489,1458,353,369,0,0,0,0,385,377,337,361,545,0,713,73,505,569,617,0
,0,441,793,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458,353,369,0,0,0
,0,385,377,337,361,545,0,713,73,505,569,617,0,0,441,793,0,0,393,0,0,89,641
,673,0,0,409,425,465,489,1458,353,369,0,0,0,0,385,377,337,361,545,0,713
,73,505,569,617,0,0,441,793,0,0,393,0,0,89,641,673,0,0,409,425,465,489,1458
,353,369,0,0,0,0,385,377,337,361,545,0,0,73,505,569,617,0,0,441,793,0,0
,393,2282,0,2179,0,0,0,0,409,425,465,489,0,0,0,0,0,0,2378,385,377,0,2370
,0,0,0,73,505,569,617,0,0,2442,793,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322
,0,0,0,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282
,0,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,2266,0,0,0,2386,0,0,0,0,0,0,0,2450,2163,0
,0,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2163,0,0,0,2163
,0,2362,0,0,0,0,0,2170,0,2163,0,0,0,0,0,2163,0,0,0,0,2163,0,2163,2163,0
,0,0,0,0,2163,0,0,0,0,0,0,0,0,2163,0,0,0,0,2163,0,0,0,0,0,0,0,2163,2282
,0,0,0,0,2163,0,0,2163,0,2163,2163,2163,2163,2163,2163,2163,2378,0,0,0,2370
,0,2163,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,2282,0,0
,0,0,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,2378,0,0,0,2370
,0,2362,0,0,0,0,0,0,0,2442,0,0,0,0,0,2426,0,0,0,0,2418,0,2314,2322,0,0,0
,0,0,2346,0,0,0,0,0,0,0,0,2402,0,0,0,0,2386,0,0,0,0,0,0,0,2450,0,0,0,0,0
,2410,0,0,2394,0,2306,2290,2338,2330,2434,2298,2354,0,0,0,0,0,0,2362}
,
{1,285,204,19,19,19,85,19,19,53,19,19,19,19,19,19,19,19,19,19,121,19,115
,19,19,19,19,19,19,204,19,19,71,19,19,19,19,19,218,169,89,85,204,122,19
,19,19,19,204,71,19,122,55,19,19,19,19,115,66,150,191,204,247,150,19,18
,167,55,19,224,66,169,262,55,48,89,19,19,19,19,247,224,19,239,122,224,224
,19,19,173,122,19,191,224,19,19,19,19,19,239,239,19,122,239,239,55,111,247
,247,83,74,239,239,77,239,239,239,239,239,239,239,173,74,239,262,239,239
,239,239,239,77,55,173,48,239,239,239,239,155,215,155,111,224,239,173,92
,239,239,239,220,239,224,224,215,239,224,239,239,239,239,239,239,239,92
,221,239,123,239,239,239,239,239,239,239,171,109,239,239,239,239,239,239
,239,239,189,239,189,183,202,219,29,171,36,109,171,171,217,189,29,125,183
,202,219,189,171,171,183,202,171,171,171,171,11,225,171,109,171,171,171
,171,202,171,217,178,11,171,171,171,171,200,56,171,171,171,171,217,178,171
,227,171,63,171,178,171,171,82,63,171,200,171,171,171,171,171,217,178,171
,82,171,171,171,171,171,171,171,171,171,171,171,171,171,171,171,86,171,15
,15,15,63,15,15,9,15,15,15,15,15,15,63,15,15,15,24,15,0,175,15,15,15,15
,15,0,15,15,63,15,15,15,15,15,59,0,0,5,61,179,15,15,15,15,180,237,15,0,0
,15,15,15,15,32,182,240,93,94,95,26,15,0,0,0,15,168,64,172,98,0,0,42,15
,15,15,15,0,168,15,172,168,248,172,15,15,249,43,15,251,44,15,15,15,15,15
,187,168,15,172,102,187,103,255,4,45,187,168,257,172,4,146,69,187,106,261
,187,187,46,263,47,72,267,49,75,270,50,187,51,157,187,187,187,187,187,187
,207,78,187,187,187,187,4,276,209,278,52,187,187,187,187,80,161,187,118
,283,187,187,284,187,187,187,285,187,285,187,285,285,4,187,285,187,187,187
,187,187,187,148,187,285,187,187,187,187,187,187,187,187,285,187,187,187
,187,187,148,285,187,148,148,285,285,285,285,285,285,285,285,285,148,285
,285,148,148,148,148,285,285,148,285,148,148,148,148,285,148,285,285,285
,148,148,148,148,285,285,148,148,148,148,285,285,148,285,148,285,148,285
,148,148,285,285,148,285,148,148,148,148,148,285,285,148,285,148,148,148
,148,148,148,148,148,148,148,148,148,148,148,148,194,148,285,285,194,285
,194,194,194,194,194,194,285,194,194,285,285,194,285,285,194,194,194,194
,194,194,194,194,285,194,194,194,194,194,285,285,285,285,194,285,194,194
,194,194,194,137,285,21,285,194,194,194,194,21,285,285,285,137,285,285,194
,137,137,285,194,285,285,285,285,137,137,137,194,194,194,194,285,137,194
,285,285,285,285,194,194,21,285,194,285,285,194,194,194,194,194,108,285
,194,285,108,285,108,108,108,108,108,285,285,108,108,285,21,108,285,285
,108,108,108,108,108,108,108,285,285,108,108,108,108,108,285,285,137,285
,285,285,108,108,108,108,285,205,285,58,285,108,108,108,108,58,285,285,285
,205,285,285,108,205,205,285,108,285,285,285,285,205,205,205,108,108,108
,108,285,285,108,285,285,285,285,108,108,58,285,108,285,285,108,108,108
,108,108,105,285,108,285,105,285,105,105,105,105,105,285,285,105,105,285
,58,105,285,285,105,105,105,105,105,105,105,285,285,105,105,105,105,105
,285,285,205,285,285,285,105,105,105,105,285,285,285,285,285,105,105,105
,105,223,285,285,285,285,285,285,105,285,285,285,105,223,285,285,285,223
,223,285,105,105,105,105,285,223,105,285,285,285,285,105,105,285,285,105
,285,285,105,105,105,105,105,210,285,105,285,210,285,285,285,285,285,285
,285,210,285,285,285,210,210,210,210,210,285,285,285,210,210,210,210,210
,210,285,223,285,285,210,285,210,210,210,285,223,223,285,16,223,285,285
,210,285,285,285,210,16,16,285,210,285,16,285,210,210,210,210,16,16,16,16
,16,285,285,210,210,285,210,285,285,285,210,210,210,210,211,210,210,210
,211,210,285,285,285,285,285,285,211,285,16,285,211,211,211,211,211,285
,285,285,211,211,211,211,211,211,285,285,285,285,211,285,211,211,211,285
,16,285,285,285,285,285,285,211,285,16,285,211,285,285,285,211,16,285,285
,211,211,211,211,285,285,285,285,285,285,285,211,211,133,211,285,285,285
,211,211,211,211,285,211,211,211,285,211,285,133,133,285,285,285,133,285
,133,285,285,285,285,133,285,285,133,133,133,285,285,285,133,285,285,133
,133,133,285,133,133,264,285,133,285,285,133,285,285,285,133,285,285,264
,285,133,285,264,264,285,133,285,285,285,285,264,133,285,133,285,236,285
,285,285,133,264,133,133,285,133,133,133,133,133,133,133,236,236,2,285,285
,236,133,133,133,2,264,133,236,236,285,236,236,236,285,2,2,236,285,285,236
,285,236,285,236,236,236,2,2,285,285,236,285,264,285,285,285,264,285,285
,236,285,2,2,236,236,285,285,285,2,2,236,285,236,236,285,2,285,285,236,152
,285,236,285,236,236,236,236,236,236,236,285,285,285,152,152,152,236,236
,236,152,285,236,152,152,152,285,152,285,285,285,285,152,152,152,285,285
,152,152,152,285,285,285,152,285,285,285,152,285,152,152,285,285,285,285
,152,152,152,152,285,285,285,285,285,152,152,152,152,285,254,285,152,152
,152,152,152,152,73,152,285,152,254,73,285,285,254,254,73,285,285,285,285
,285,254,73,285,285,285,73,285,285,285,285,285,285,285,285,285,73,285,285
,285,285,285,73,73,73,285,285,73,73,73,73,285,254,285,285,285,73,285,285
,285,285,285,73,285,285,73,73,285,285,73,73,285,73,285,73,285,285,285,73
,254,285,285,285,254,73,73,285,73,206,73,73,73,73,73,73,73,73,285,81,285
,206,285,73,81,206,206,285,285,81,285,285,285,206,206,206,81,285,285,285
,81,285,285,285,285,285,285,285,285,285,81,285,285,285,285,285,81,81,81
,285,285,81,81,81,81,285,285,285,285,285,81,285,285,285,285,285,81,285,285
,81,81,285,285,81,81,285,81,285,81,285,285,285,81,285,285,206,285,285,81
,81,285,81,285,81,81,81,81,81,81,81,81,285,88,285,285,285,81,88,285,285
,285,285,88,285,285,285,285,285,285,88,285,285,285,88,285,285,285,285,285
,285,285,285,285,88,285,285,285,285,285,88,88,88,285,285,88,88,88,88,285
,285,285,285,285,88,285,285,285,285,285,88,285,285,88,88,285,285,88,88,285
,88,285,88,285,285,285,88,285,285,285,285,285,88,88,285,88,285,88,88,88
,88,88,88,88,88,285,99,285,285,285,88,99,285,285,285,285,99,285,285,285
,285,285,285,99,285,285,285,99,285,285,285,285,285,285,285,285,285,99,285
,285,285,285,285,99,99,99,285,285,99,99,99,99,285,285,285,285,285,99,285
,285,285,285,285,99,285,285,99,99,285,285,99,99,285,99,285,99,285,285,285
,99,285,285,285,285,285,99,99,285,99,285,99,99,99,99,99,99,99,99,285,14
,285,285,285,99,14,285,285,285,285,14,285,285,285,285,285,285,14,285,285
,285,14,285,285,285,285,285,285,285,285,285,14,285,285,285,285,285,14,14
,14,285,285,14,14,14,14,285,285,285,285,285,14,285,285,285,285,285,14,285
,285,14,14,285,285,14,14,285,14,285,14,285,285,285,14,285,285,285,285,285
,14,14,285,14,285,14,14,14,14,14,14,14,14,285,10,285,285,285,14,10,285,285
,285,285,10,285,285,285,285,285,285,10,285,285,285,10,285,285,285,285,285
,285,285,285,285,10,285,285,285,285,285,10,10,10,285,285,10,10,10,10,285
,285,285,285,285,10,285,285,285,285,285,10,285,285,10,10,285,285,10,10,285
,10,285,10,285,285,285,10,285,285,285,285,285,10,10,285,10,285,10,10,10
,10,10,10,10,10,285,110,285,285,285,10,110,285,285,285,285,110,285,285,285
,285,285,285,110,285,285,285,110,285,285,285,285,285,285,285,285,285,110
,285,285,285,285,285,110,110,110,285,285,110,110,110,110,285,285,285,285
,285,110,285,285,285,285,285,110,285,285,110,110,285,285,110,110,285,110
,285,110,285,285,285,110,285,285,285,285,285,110,110,285,110,285,110,110
,110,110,110,110,110,110,285,114,285,285,285,110,114,285,285,285,285,114
,285,285,285,285,285,285,114,285,285,285,114,285,285,285,285,285,285,285
,285,285,114,285,285,285,285,285,114,114,114,285,285,114,114,114,114,285
,285,285,285,285,114,285,285,285,285,285,114,285,285,114,114,285,285,114
,114,285,114,285,114,285,285,285,114,285,285,285,285,285,114,114,285,114
,285,114,114,114,114,114,114,114,114,285,17,285,285,285,114,17,285,285,285
,285,17,285,285,285,285,285,285,17,285,285,285,17,285,285,285,285,285,285
,285,285,285,17,285,285,285,285,285,17,17,17,285,285,17,17,17,17,285,285
,285,285,285,17,285,285,285,285,285,17,285,285,17,17,285,285,17,17,285,17
,285,17,285,285,285,17,285,285,285,285,285,17,17,285,17,285,17,17,17,17
,17,17,17,17,285,12,285,285,285,17,12,285,285,285,285,12,285,285,285,285
,285,285,12,285,285,285,12,285,285,285,285,285,285,285,285,285,12,285,285
,285,285,285,12,12,12,285,285,12,12,12,12,285,285,285,285,285,12,285,285
,285,285,285,12,285,285,12,12,285,285,12,12,285,12,285,12,285,285,285,12
,285,285,285,285,285,12,12,285,12,285,12,12,12,12,12,12,12,12,285,149,285
,285,285,12,149,285,285,285,285,149,285,285,285,285,285,285,149,285,285
,285,149,285,285,285,285,285,285,285,285,285,149,285,285,285,285,285,149
,149,149,285,285,149,149,149,149,285,285,285,285,285,149,285,285,285,285
,285,149,285,285,149,149,285,285,149,149,285,149,285,149,285,285,285,149
,285,285,285,285,285,149,149,285,149,285,149,149,149,149,149,149,149,149
,285,28,285,285,285,149,28,285,285,285,285,28,285,285,285,285,285,285,28
,285,285,285,28,285,285,285,285,285,285,285,285,285,28,285,285,285,285,285
,28,28,28,285,285,28,28,28,28,285,285,285,285,285,28,285,285,285,285,285
,28,285,285,28,28,285,285,28,28,285,28,285,28,285,285,285,28,285,285,285
,285,285,28,28,285,28,285,28,28,28,28,28,28,28,28,285,31,285,285,285,28
,31,285,285,285,285,31,285,285,285,285,285,285,31,285,285,285,31,285,285
,285,285,285,285,285,285,285,31,285,285,285,285,285,31,31,31,285,285,31
,31,31,31,285,285,285,285,285,31,285,285,285,285,285,31,285,285,31,31,285
,285,31,31,285,31,285,31,285,285,285,31,285,285,285,285,285,31,31,285,31
,285,31,31,31,31,31,31,31,31,285,33,285,285,285,31,33,285,285,285,285,33
,285,285,285,285,285,285,33,285,285,285,33,285,285,285,285,285,285,285,285
,285,33,285,285,285,285,285,33,33,33,285,285,33,33,33,33,285,285,285,285
,285,33,285,285,285,285,285,33,285,285,33,33,285,285,33,33,285,33,285,33
,285,285,285,33,285,285,285,285,285,33,33,285,33,285,33,33,33,33,33,33,33
,33,285,190,285,285,285,33,190,285,285,285,285,190,285,285,285,285,285,285
,190,285,285,285,190,285,285,285,285,285,285,285,285,285,190,285,285,285
,285,285,190,190,190,285,285,190,190,190,190,285,285,285,285,285,190,285
,285,285,285,285,190,285,285,190,190,285,285,190,190,285,190,285,190,285
,285,285,190,285,285,285,285,285,190,190,285,190,285,190,190,190,190,190
,190,190,190,285,34,285,285,285,190,34,285,285,285,285,34,285,285,285,285
,285,285,34,285,285,285,34,285,285,285,285,285,285,285,285,285,34,285,285
,285,285,285,34,34,34,285,285,34,34,34,34,285,285,285,285,285,34,285,285
,285,285,285,34,285,285,34,34,285,285,34,34,285,34,285,34,285,285,285,34
,285,285,285,285,285,34,34,285,34,285,34,34,34,34,34,34,34,34,285,35,285
,285,285,34,35,285,285,285,285,35,285,285,285,285,285,285,35,285,285,285
,35,285,285,285,285,285,285,285,285,285,35,285,285,285,285,285,35,35,35
,285,285,35,35,35,35,285,285,285,285,285,35,285,285,285,285,285,35,285,285
,35,35,285,285,35,35,285,35,285,35,285,285,285,35,285,285,285,285,285,35
,35,285,35,285,35,35,35,35,35,35,35,35,285,37,285,285,285,35,37,285,285
,285,285,37,285,285,285,285,285,253,37,285,285,285,37,285,285,285,285,285
,285,253,285,285,37,253,253,285,285,285,37,37,37,253,285,37,37,37,37,285
,285,285,285,285,37,285,285,285,285,285,37,285,285,37,37,285,285,37,37,285
,37,285,37,285,253,285,37,285,285,285,285,285,37,37,285,37,285,37,37,37
,37,37,37,37,37,234,285,285,285,234,37,253,285,285,285,253,285,234,285,285
,285,234,234,234,234,234,285,285,285,234,285,285,234,234,234,234,285,285
,285,285,285,234,234,234,285,285,285,285,285,285,285,285,234,285,285,285
,234,285,285,285,234,285,285,285,234,234,234,234,285,38,285,285,285,285
,38,234,234,285,234,38,285,285,234,234,234,234,38,234,234,234,38,234,285
,285,285,285,285,285,285,285,38,285,285,285,285,285,38,38,38,285,285,38
,38,38,38,285,285,285,285,285,38,285,285,285,285,285,38,285,285,38,38,285
,285,38,38,285,38,285,38,285,285,285,38,285,285,285,285,285,38,38,285,38
,285,38,38,38,38,38,38,38,38,285,65,285,285,285,38,65,285,285,285,285,65
,285,285,285,285,285,285,65,285,285,285,65,285,285,285,285,285,285,285,285
,285,65,285,285,285,285,285,65,65,65,285,285,65,65,65,65,285,285,285,285
,285,65,285,285,285,285,285,65,285,285,65,65,285,285,65,65,285,65,285,65
,285,285,285,65,285,285,285,285,285,65,65,285,65,285,65,65,65,65,65,65,65
,65,285,271,285,285,285,65,271,285,285,285,285,271,285,285,285,285,285,285
,271,285,285,285,271,285,285,285,285,285,285,285,285,285,271,285,285,285
,285,285,271,271,271,285,285,271,271,271,271,285,285,285,285,285,271,285
,285,285,285,285,271,285,285,271,271,285,285,271,271,285,271,285,271,285
,285,285,271,285,140,285,285,285,271,271,285,271,285,271,271,271,271,271
,271,271,271,140,285,285,285,140,271,285,285,285,285,285,285,140,285,140
,285,285,285,285,285,140,285,285,140,285,140,285,140,140,285,140,285,285
,285,140,285,285,285,285,285,140,140,140,140,285,285,285,285,140,285,285
,285,140,140,285,285,140,285,285,285,285,285,140,285,285,140,285,140,140
,140,140,140,140,140,140,140,285,285,232,285,140,140,232,285,285,285,285
,285,285,285,232,285,285,285,232,232,232,232,232,285,285,285,232,285,285
,232,232,232,285,285,285,285,285,285,232,232,232,285,285,285,285,285,285
,285,285,232,285,285,285,232,285,285,285,232,285,285,285,232,232,232,232
,285,128,285,285,285,285,285,232,232,285,232,285,285,285,232,232,232,232
,128,232,232,232,128,232,285,285,285,285,285,285,128,285,128,285,285,285
,285,285,128,285,285,128,285,128,285,128,128,285,128,285,285,285,128,285
,285,285,285,285,128,128,128,128,285,285,285,285,128,285,285,285,128,128
,285,285,128,285,285,285,285,120,128,285,285,128,285,128,128,128,128,128
,128,128,128,128,285,285,120,285,128,128,120,285,285,285,285,285,285,285
,120,285,120,285,285,285,285,285,120,285,285,120,285,120,285,120,120,285
,120,285,285,285,120,285,285,285,285,285,120,120,120,120,285,285,285,285
,120,285,285,285,120,120,285,285,120,285,285,285,285,136,120,285,285,120
,285,120,120,120,120,120,120,120,120,120,285,285,136,285,120,120,136,285
,285,285,285,285,285,285,136,285,136,285,285,285,285,285,136,285,285,136
,285,136,285,136,136,285,136,285,285,285,136,285,285,285,285,285,136,136
,136,136,285,285,285,285,136,285,285,285,136,136,285,285,136,285,285,285
,285,165,136,285,285,136,285,136,136,136,136,136,136,136,136,136,285,285
,165,285,136,136,165,285,285,285,285,285,285,285,285,165,165,285,285,285
,285,285,165,285,285,165,285,165,285,165,165,285,165,285,285,285,165,285
,285,285,285,285,165,165,165,165,285,285,285,285,165,285,285,285,165,165
,285,285,165,285,285,285,285,154,165,285,285,165,285,165,165,165,165,165
,165,165,165,165,285,285,154,285,165,165,154,285,285,285,285,285,285,285
,285,285,154,285,285,285,285,285,154,285,285,154,285,154,285,154,154,285
,154,285,285,285,154,285,285,285,285,285,154,154,154,154,285,285,285,285
,154,285,285,285,154,154,285,285,154,285,285,285,285,285,154,285,285,154
,285,154,154,154,154,154,154,154,154,154,285,285,186,285,154,154,186,285
,285,285,285,285,285,285,186,285,285,285,186,186,186,186,186,285,285,285
,186,186,186,186,186,186,285,186,285,130,130,285,186,186,186,285,130,285
,285,285,285,130,285,186,285,130,130,186,160,285,285,285,285,130,285,186
,186,186,186,285,285,130,285,285,285,160,186,186,130,160,285,285,285,186
,186,186,186,285,285,160,186,285,186,285,285,160,285,285,160,285,160,285
,160,160,130,160,285,285,285,160,285,285,130,285,285,160,160,160,160,285
,285,130,130,160,285,130,285,160,160,285,285,160,285,285,285,285,285,160
,285,285,160,285,160,160,160,160,160,160,160,160,160,285,285,241,285,160
,160,241,285,285,285,285,285,285,285,241,285,285,285,241,241,241,241,241
,285,285,285,241,285,285,241,241,241,285,285,285,285,285,285,241,241,241
,285,285,285,285,285,285,285,285,241,285,285,285,241,285,285,285,285,285
,285,285,241,241,241,241,285,285,285,285,285,285,285,241,241,285,241,285
,285,285,241,241,241,241,242,241,241,241,242,241,285,285,285,285,285,285
,242,285,285,285,242,242,242,242,242,285,285,285,242,285,285,242,242,242
,285,285,285,285,285,285,242,242,242,285,285,285,285,285,285,285,285,242
,285,285,285,242,285,285,285,285,285,285,285,242,242,242,242,285,285,285
,285,285,285,285,242,242,285,242,285,285,285,242,242,242,242,244,242,242
,242,244,242,285,285,285,285,285,285,244,285,285,285,244,244,244,244,244
,285,285,285,244,285,285,244,244,244,285,285,285,285,285,285,244,244,244
,285,285,285,285,285,285,285,285,244,285,285,285,244,285,285,285,285,285
,285,285,244,244,244,244,285,285,285,285,285,285,285,244,244,285,244,285
,285,285,244,244,244,244,266,244,244,244,266,244,285,285,285,285,285,285
,266,285,285,285,266,266,266,266,266,285,285,285,266,285,285,266,266,266
,285,285,285,285,266,285,266,266,266,285,285,285,285,285,285,285,285,266
,285,285,285,266,285,285,285,266,285,285,285,266,266,266,266,285,285,285
,285,285,285,285,266,266,285,285,285,285,285,266,266,266,266,269,266,285
,266,269,266,285,285,285,285,285,285,269,285,285,285,269,269,269,269,269
,285,285,285,269,285,285,269,269,269,285,285,285,228,269,285,269,269,269
,285,285,285,285,285,285,228,285,269,285,228,228,269,145,285,285,269,285
,228,285,269,269,269,269,228,285,285,285,285,285,145,269,269,285,145,285
,285,285,269,269,269,269,285,269,145,269,285,269,285,228,145,228,228,145
,285,145,285,145,145,285,145,285,285,285,145,285,285,228,285,285,145,145
,145,145,285,285,228,228,145,285,228,285,145,145,285,285,145,285,285,285
,285,285,145,285,285,145,285,145,145,145,145,145,145,145,145,145,285,285
,273,285,145,145,273,285,285,285,285,285,285,285,273,285,285,285,273,273
,273,273,273,285,285,3,273,285,285,273,273,273,3,285,285,285,273,285,273
,273,273,285,3,3,3,285,285,285,285,273,285,285,285,273,3,3,285,273,285,285
,285,273,273,273,273,285,285,285,285,3,3,285,273,273,246,285,3,3,285,273
,273,273,273,3,273,285,273,285,273,285,246,246,285,285,285,246,285,285,285
,285,285,285,246,246,285,246,246,246,285,285,285,246,285,285,246,285,246
,285,246,246,285,285,285,285,230,246,285,285,285,285,285,285,285,285,246
,285,230,285,285,246,230,230,285,285,285,285,285,246,230,259,285,285,285
,246,230,285,246,285,246,246,246,246,246,246,246,259,259,285,285,285,259
,246,246,246,285,285,246,259,259,230,259,259,259,285,285,285,259,285,285
,259,285,259,285,259,259,285,285,230,285,285,259,285,285,285,285,285,230
,230,285,259,230,285,285,285,259,285,285,285,285,285,259,285,259,281,285
,285,285,285,259,285,285,259,285,259,259,259,259,259,259,259,281,285,285
,285,281,285,259,259,285,285,285,259,285,285,281,285,285,285,285,285,281
,285,285,281,285,281,285,281,281,285,281,285,285,285,281,285,285,285,285
,285,281,281,285,281,285,285,285,285,281,285,285,285,281,281,285,285,281
,285,285,285,285,213,281,285,285,281,285,281,281,281,281,281,281,281,281
,281,285,213,213,285,281,281,213,285,285,285,285,285,285,213,213,285,213
,213,213,285,285,285,213,285,285,213,213,213,285,213,213,285,285,285,285
,285,213,285,285,285,285,285,285,285,285,213,285,285,285,285,213,285,285
,285,285,285,285,285,213,285,285,285,285,285,213,285,285,213,285,213,213
,213,213,213,213,213,13,285,285,285,13,285,213,285,285,285,285,213,13,285
,141,141,13,285,13,285,285,141,285,285,285,285,141,285,13,285,141,141,13
,13,13,285,285,285,141,285,285,13,13,13,13,285,141,13,285,285,13,13,13,141
,285,285,285,285,285,285,285,13,285,285,285,13,285,285,285,141,285,285,285
,13,13,13,13,285,285,141,285,285,285,30,13,13,285,30,285,285,285,13,13,13
,13,30,141,285,13,30,141,30,285,285,285,285,285,285,285,285,285,30,285,285
,285,30,30,30,285,285,285,285,285,285,30,30,30,30,285,285,30,285,285,30
,30,30,285,285,285,285,285,285,285,285,30,285,285,285,30,285,285,285,285
,285,285,285,30,30,30,30,285,285,285,285,285,285,285,30,30,285,285,285,285
,285,30,30,30,30,177,285,177,30,285,177,285,177,177,285,285,285,285,285
,285,285,285,177,285,285,285,177,285,285,285,285,100,285,285,285,100,177
,100,100,100,100,100,177,285,100,100,285,177,285,177,177,100,100,100,100
,100,177,100,285,285,100,100,285,285,285,177,285,177,285,285,177,285,285
,285,100,285,285,285,177,285,285,285,285,100,177,285,285,177,285,177,177
,177,177,177,177,177,176,285,176,285,285,176,177,176,176,285,285,285,285
,100,285,285,285,176,285,285,285,176,100,285,285,285,285,285,285,100,285
,176,285,285,285,285,285,176,285,285,285,285,176,285,176,176,285,285,285
,285,285,176,285,285,285,285,285,285,285,285,176,285,176,285,285,176,285
,285,285,285,285,285,285,176,285,285,285,285,285,176,285,285,176,285,176
,176,176,176,176,176,176,193,285,285,285,285,285,176,285,193,285,193,285
,285,285,193,193,193,285,285,285,285,193,285,193,193,193,285,193,285,285
,285,285,193,193,193,285,285,285,285,285,285,285,285,193,285,285,285,193
,285,285,285,285,285,285,285,193,193,193,193,285,285,285,285,285,285,285
,193,193,285,285,285,285,285,193,193,193,193,197,197,285,193,285,197,285
,197,197,197,197,197,197,285,197,197,285,285,285,285,197,197,197,197,197
,197,285,197,197,285,197,197,285,285,285,285,285,285,285,285,198,198,285
,285,197,198,285,198,198,198,198,198,198,197,198,198,285,285,285,285,198
,198,198,198,198,198,285,198,198,285,198,198,285,285,285,285,285,285,285
,197,285,285,285,285,198,285,285,285,197,285,285,285,285,198,285,197,285
,285,285,199,199,285,285,285,199,285,199,199,199,199,199,199,285,199,199
,285,285,285,285,198,199,199,199,199,199,285,199,199,198,199,199,285,285
,285,285,198,285,285,285,285,285,91,285,199,285,285,285,285,285,91,285,285
,199,285,285,91,91,91,199,285,285,285,285,285,91,91,91,91,285,285,285,285
,285,91,91,91,285,285,199,285,285,285,285,285,91,285,285,199,91,91,285,285
,285,285,199,285,91,91,91,91,285,285,285,285,188,285,285,91,91,285,285,285
,188,285,91,91,91,91,188,188,188,91,285,285,285,188,285,188,188,188,285
,188,285,285,285,285,188,188,188,285,117,285,285,285,285,285,285,188,117
,285,285,188,285,285,117,117,117,285,285,188,188,188,188,117,117,117,117
,285,285,285,188,188,117,117,117,285,184,188,188,188,188,285,285,117,188
,285,285,117,117,285,184,184,184,285,285,117,117,117,117,184,184,184,285
,285,285,285,117,117,184,184,184,285,184,117,117,117,117,285,285,184,117
,184,285,184,285,285,285,285,285,285,285,184,184,184,184,285,285,285,184
,113,285,285,184,184,285,285,285,113,285,184,184,184,184,113,113,113,184
,285,285,285,285,285,113,113,113,113,285,285,285,285,285,113,113,113,285
,285,285,285,285,285,285,285,113,285,285,285,113,113,285,285,285,285,285
,285,113,113,113,113,285,285,285,285,285,285,285,113,113,285,285,285,285
,285,113,113,113,113,195,195,285,113,285,195,285,195,195,195,195,195,195
,285,195,195,285,285,285,285,195,195,195,195,195,195,285,195,195,285,195
,195,285,285,285,285,285,285,285,285,196,196,285,285,195,196,285,196,196
,196,196,196,196,195,196,196,285,285,285,285,196,196,196,196,196,196,285
,196,196,54,196,196,285,285,285,285,285,285,285,195,285,285,285,285,196
,285,54,285,195,285,54,229,285,196,285,195,285,285,285,285,54,285,285,229
,285,285,54,229,229,285,285,54,285,54,54,229,285,285,285,196,54,229,285
,285,285,285,54,285,196,54,285,285,285,285,54,196,285,285,54,285,285,285
,54,285,57,285,229,285,54,229,285,54,285,54,54,54,54,54,54,54,54,57,285
,285,229,57,54,285,285,285,285,285,285,229,229,57,285,229,285,285,285,57
,285,285,285,285,57,285,57,57,285,285,285,285,285,57,285,285,285,285,285
,57,285,285,57,285,285,285,285,57,285,285,285,57,285,285,285,57,285,163
,285,163,285,57,163,285,57,285,57,57,57,57,57,57,57,57,163,285,285,285,163
,57,285,285,285,285,285,285,285,285,163,285,285,285,285,285,163,285,285
,285,285,163,285,163,163,285,285,285,285,285,163,285,285,285,285,285,285
,285,285,163,285,163,285,285,163,285,285,285,285,285,285,285,163,8,285,285
,285,285,163,285,285,163,285,163,163,163,163,163,163,163,8,285,285,285,8
,285,163,285,285,285,285,285,285,285,8,285,285,285,285,285,8,285,285,285
,285,8,285,8,8,285,285,285,285,285,8,285,285,285,285,285,8,285,285,8,285
,285,285,285,8,285,285,285,8,285,285,285,8,285,285,285,285,265,8,285,285
,8,285,8,8,8,8,8,8,8,8,265,265,265,285,285,8,285,285,285,265,265,265,285
,285,285,285,285,265,265,265,265,285,285,285,285,285,285,285,285,265,285
,265,285,265,67,285,285,285,285,285,285,265,265,265,265,285,285,285,285
,285,285,67,265,265,285,67,285,285,285,265,265,265,265,285,285,67,265,285
,285,285,285,67,285,285,285,285,67,285,67,67,285,285,285,285,285,67,285
,285,285,285,285,67,285,285,67,285,285,285,285,67,285,285,285,67,285,285
,285,67,285,20,285,285,285,67,285,285,67,285,67,67,67,67,67,67,67,67,20
,285,285,285,20,67,285,285,285,285,285,285,285,285,20,285,285,285,285,285
,20,285,285,285,285,20,285,20,20,285,285,285,285,285,20,285,285,285,285
,285,20,285,285,20,285,285,285,285,20,285,285,285,20,285,285,285,20,285
,22,285,285,285,20,285,285,20,285,20,20,20,20,20,20,20,20,22,285,285,285
,22,20,285,285,285,285,285,285,285,285,22,285,285,285,285,285,22,285,285
,285,285,22,285,22,22,285,285,285,285,285,22,285,285,285,285,285,22,285
,285,22,285,285,285,285,22,285,285,285,22,285,285,285,22,285,23,285,285
,285,22,285,285,22,285,22,22,22,22,22,22,22,22,23,285,285,285,23,22,285
,285,285,285,285,285,285,285,23,285,285,285,285,285,23,285,285,285,285,23
,285,23,23,285,285,285,285,285,23,285,285,285,285,285,23,285,285,23,285
,285,285,285,23,285,285,285,23,285,285,285,23,285,41,285,285,285,23,285
,285,23,285,23,23,23,23,23,23,23,23,41,285,285,285,41,23,285,285,285,285
,285,285,285,285,41,285,285,285,285,285,41,285,285,285,285,41,285,41,41
,285,285,285,285,285,41,285,285,285,285,285,41,285,285,41,285,285,285,285
,41,285,285,285,41,285,285,285,41,285,285,285,285,285,41,285,285,41,285
,41,41,41,41,41,41,41,41,97,285,285,285,285,41,285,285,97,285,285,285,285
,285,97,97,97,6,285,285,285,285,285,97,97,97,285,285,285,285,285,285,97
,97,97,285,285,285,6,285,285,285,285,97,285,285,285,97,285,285,285,285,6
,6,6,97,97,97,97,285,285,6,6,6,285,285,97,97,285,285,6,6,6,97,97,97,97,272
,285,285,97,6,285,272,285,6,285,285,285,285,285,285,285,6,6,6,6,272,272
,272,285,285,285,285,6,6,272,272,272,285,285,6,6,6,6,272,272,272,6,285,285
,285,285,285,285,285,272,285,285,285,272,235,285,285,285,285,285,285,272
,272,272,272,285,285,285,285,285,285,235,272,272,285,235,285,285,285,272
,272,272,272,235,285,235,272,285,285,285,285,235,285,285,285,285,235,285
,235,235,285,285,285,285,285,235,285,285,285,285,285,285,285,285,235,285
,285,285,235,235,285,285,285,285,285,285,285,235,285,285,285,285,285,235
,285,285,235,285,235,235,235,235,235,235,235,275,285,285,285,285,285,235
,285,275,285,285,285,285,285,275,275,275,7,285,285,285,285,285,275,275,275
,285,285,285,285,285,285,275,275,275,285,285,285,7,285,285,285,285,275,285
,285,285,275,285,285,285,285,7,7,7,275,275,275,275,285,285,7,7,7,285,285
,275,275,285,285,7,7,7,275,275,275,275,285,285,285,275,7,285,285,285,7,282
,285,282,285,285,285,285,7,7,7,7,285,285,285,285,285,285,282,7,7,285,282
,285,285,285,7,7,7,7,285,285,282,7,285,285,285,285,282,285,285,285,285,282
,285,282,282,285,285,285,285,285,282,285,285,285,285,285,285,285,285,282
,282,285,285,285,282,285,285,285,285,285,285,285,282,285,285,285,151,285
,282,285,285,282,285,282,282,282,282,282,282,282,151,151,151,285,285,285
,282,285,285,151,151,151,285,285,285,285,285,285,151,151,151,285,116,285
,285,285,285,285,285,151,285,285,285,151,285,285,116,116,116,285,285,151
,151,151,151,116,116,116,285,285,285,285,151,151,116,116,116,285,285,151
,151,151,151,285,285,116,151,285,285,116,208,285,208,285,285,285,285,116
,116,116,116,285,285,285,285,285,285,208,116,116,285,208,285,285,285,116
,116,116,116,285,285,208,116,285,285,285,285,208,285,285,285,285,208,285
,208,208,285,285,285,285,285,208,285,285,285,285,285,285,285,285,208,285
,285,285,285,208,285,285,285,285,285,285,285,208,285,285,285,285,285,208
,285,285,208,285,208,208,208,208,208,208,208,285,101,285,285,285,101,208
,101,101,101,101,101,119,285,101,101,285,285,285,285,285,101,101,101,101
,101,101,101,285,119,101,101,285,119,285,285,285,285,285,285,285,119,285
,119,101,285,285,285,285,119,285,285,285,101,119,285,119,119,285,285,285
,285,285,119,285,285,285,285,285,285,285,285,119,285,285,285,285,119,285
,101,285,285,285,285,285,119,212,285,101,285,285,119,285,285,119,101,119
,119,119,119,119,119,119,212,285,285,285,212,285,119,285,285,285,285,285
,212,285,212,285,285,285,285,285,212,285,285,285,285,212,285,212,212,285
,285,285,285,285,212,285,285,285,285,285,285,285,285,212,285,285,285,285
,212,285,285,285,285,285,285,285,212,285,162,285,285,285,212,162,285,212
,285,212,212,212,212,212,212,212,285,162,285,285,285,162,212,285,285,285
,285,285,285,285,285,162,285,285,285,285,285,162,285,285,285,285,162,285
,162,162,285,285,285,285,285,162,285,285,285,285,285,285,285,285,162,285
,285,285,285,162,285,285,285,285,285,285,285,162,222,285,222,285,285,162
,285,285,162,285,162,162,162,162,162,162,162,222,285,285,285,222,285,162
,285,285,285,285,285,285,285,222,285,285,285,285,285,222,285,285,285,285
,222,285,222,222,285,285,285,285,285,222,285,285,285,285,285,285,285,285
,222,285,285,285,285,222,285,285,285,285,285,285,285,222,226,285,226,285
,285,222,285,285,222,285,222,222,222,222,222,222,222,226,285,285,285,226
,285,222,285,285,285,285,285,285,285,226,285,285,285,285,285,226,285,285
,285,285,226,285,226,226,285,285,285,285,285,226,285,285,285,285,285,285
,285,285,226,285,285,285,285,226,285,285,285,285,285,285,285,226,285,285
,285,231,285,226,285,285,226,285,226,226,226,226,226,226,226,231,231,231
,285,285,285,226,285,285,231,231,231,285,285,285,285,285,285,231,231,231
,285,104,285,285,285,285,285,285,231,285,285,285,231,285,285,104,104,104
,285,285,231,231,231,231,104,104,104,285,285,285,285,231,231,104,104,104
,285,233,231,231,231,231,285,285,104,231,285,285,104,285,285,233,233,233
,285,285,104,104,104,104,233,233,233,285,285,285,285,104,104,233,233,233
,285,285,104,104,104,104,285,285,233,104,285,285,233,126,285,285,285,285
,285,285,233,233,233,233,285,285,285,285,285,285,126,233,233,285,126,285
,285,285,233,233,233,233,285,285,126,233,285,285,285,285,126,285,285,285
,285,126,285,126,126,285,285,285,285,285,126,285,285,285,285,285,285,285
,285,126,285,285,285,285,126,285,285,285,285,285,285,285,126,285,285,285
,285,285,126,170,285,126,285,126,126,126,126,126,126,126,285,285,285,170
,170,170,126,285,285,285,126,285,170,170,170,285,285,285,131,131,285,170
,170,170,285,131,285,285,285,285,131,285,170,285,131,131,170,127,285,285
,285,285,131,285,170,170,170,170,285,285,131,285,285,285,127,170,170,131
,127,285,285,285,170,170,170,170,127,285,127,170,285,285,285,285,127,285
,285,285,285,127,285,127,127,131,285,285,285,285,127,285,285,131,285,285
,285,285,285,127,285,285,131,131,127,285,131,285,285,285,285,285,127,285
,285,285,238,285,127,285,285,127,285,127,127,127,127,127,127,127,238,238
,238,285,285,285,127,285,285,238,238,238,285,285,285,285,285,285,238,238
,238,285,90,285,285,285,285,285,285,238,285,285,285,238,285,285,90,90,90
,285,285,238,238,238,238,90,90,90,285,285,285,285,238,238,90,90,90,285,107
,238,238,238,238,285,285,90,238,285,285,90,285,285,107,107,107,285,285,90
,90,90,90,107,107,107,285,285,285,285,90,90,107,107,107,285,285,90,90,90
,90,285,285,107,90,285,285,107,181,285,181,285,285,285,285,107,107,107,107
,285,285,285,285,285,285,181,107,107,285,181,285,285,285,107,107,107,107
,285,285,181,107,285,285,285,285,181,285,285,285,285,181,285,181,181,285
,285,285,285,285,181,285,285,285,285,285,285,285,285,181,285,285,285,285
,181,285,285,285,285,285,285,285,181,285,285,285,243,285,181,285,285,181
,285,181,181,181,181,181,181,181,243,243,243,285,285,285,181,285,285,243
,243,243,285,285,285,129,129,285,243,243,243,285,129,285,285,285,285,129
,285,243,285,129,129,243,134,285,285,285,285,129,285,243,243,243,243,285
,285,129,285,285,285,134,243,243,129,134,285,285,285,243,243,243,243,285
,285,134,243,285,285,285,285,134,285,285,285,285,134,285,134,134,129,285
,285,285,285,134,285,285,129,285,285,285,285,285,134,285,285,129,129,134
,285,129,285,285,285,285,285,134,245,285,285,285,285,134,285,285,134,285
,134,134,134,134,134,134,134,245,285,285,285,245,285,134,285,285,285,134
,285,245,285,245,285,285,285,285,285,245,285,285,285,285,245,285,245,245
,285,285,285,285,285,245,285,285,285,285,285,285,285,285,245,285,285,285
,285,245,285,285,285,285,285,285,285,245,285,285,285,185,285,245,285,285
,245,285,245,245,245,245,245,245,245,185,185,185,285,285,285,245,285,285
,185,185,185,285,285,285,142,142,285,185,185,185,285,142,285,285,285,285
,142,285,185,285,142,142,185,250,285,250,285,285,142,285,185,185,185,185
,285,285,142,285,285,285,250,185,185,142,250,285,285,285,185,185,185,185
,285,285,250,185,285,285,285,142,250,285,285,285,285,250,285,250,250,142
,285,285,285,285,250,285,285,285,285,285,285,285,285,250,285,285,142,285
,250,285,142,285,285,285,285,285,250,256,285,256,285,285,250,285,285,250
,285,250,250,250,250,250,250,250,256,285,285,285,256,285,250,285,285,285
,285,285,285,285,256,285,285,285,285,285,256,285,285,285,285,256,285,256
,256,285,285,285,285,285,256,285,285,285,285,285,285,285,285,256,285,285
,285,285,256,285,285,285,285,285,285,285,256,258,285,285,285,285,256,285
,285,256,285,256,256,256,256,256,256,256,258,285,285,285,258,285,256,285
,285,285,285,285,258,285,258,285,285,285,285,285,258,285,285,285,285,258
,285,258,258,285,285,285,285,285,258,285,285,285,285,285,285,285,285,258
,285,285,285,285,258,285,285,285,285,285,285,285,258,135,285,285,285,285
,258,285,285,258,285,258,258,258,258,258,258,258,135,285,285,285,135,285
,258,285,285,285,285,285,135,285,135,285,285,285,285,285,135,285,285,285
,285,135,285,135,135,285,285,285,285,285,135,285,285,285,285,285,285,285
,285,135,285,285,285,285,135,285,285,285,285,285,285,285,135,260,285,285
,285,285,135,285,285,135,285,135,135,135,135,135,135,135,260,285,285,285
,260,285,135,285,285,285,285,285,285,285,260,285,285,285,285,285,260,285
,285,285,285,260,285,260,260,285,285,285,285,285,260,285,285,285,285,285
,285,285,285,260,260,285,285,285,260,285,285,285,285,285,285,285,260,68
,285,285,285,285,260,285,285,260,285,260,260,260,260,260,260,260,68,285
,285,285,68,285,260,285,285,285,285,285,68,285,68,285,285,285,285,285,68
,285,285,285,285,68,285,68,68,285,285,285,285,285,68,285,285,285,285,285
,285,285,285,68,285,285,285,285,68,285,285,285,285,285,285,285,68,138,285
,285,285,285,68,285,285,68,285,68,68,68,68,68,68,68,138,285,285,285,138
,285,68,285,285,285,285,285,285,285,138,285,285,285,285,285,138,285,285
,285,285,138,285,138,138,285,285,285,285,285,138,285,285,285,285,285,285
,285,285,138,285,285,285,285,138,285,285,285,285,285,285,285,138,285,285
,285,285,285,138,268,285,138,285,138,138,138,138,138,138,138,285,285,285
,268,268,268,138,285,285,285,138,285,268,268,268,285,285,285,143,143,285
,268,268,268,285,143,285,285,285,285,143,285,268,285,143,143,268,139,285
,285,285,285,143,285,268,268,268,268,285,285,143,285,285,285,139,268,268
,143,139,285,285,285,268,268,268,268,139,285,139,268,285,285,285,143,139
,285,285,285,285,139,285,139,139,143,285,285,285,285,139,285,285,285,285
,285,285,285,285,139,285,285,143,285,139,285,143,285,285,285,285,285,139
,285,285,285,192,285,139,285,285,139,285,139,139,139,139,139,139,139,192
,192,192,285,285,285,139,285,285,192,192,192,285,285,285,285,285,285,192
,192,192,285,96,285,285,285,285,285,285,192,285,285,285,192,285,285,96,96
,96,285,285,192,192,192,192,96,96,96,285,285,285,285,192,192,96,96,96,285
,112,192,192,192,192,285,285,96,192,285,285,96,285,285,112,112,112,285,285
,96,96,96,96,112,112,112,285,285,285,285,96,96,112,112,112,285,274,96,96
,96,96,285,285,112,96,285,285,112,285,285,274,274,274,285,285,112,112,112
,112,274,274,274,285,285,285,285,112,112,274,274,274,285,147,112,112,112
,112,285,285,274,112,285,285,274,285,285,147,147,147,285,285,274,274,274
,274,147,147,147,285,285,285,285,274,274,147,147,147,285,285,274,274,274
,274,285,285,147,274,285,285,147,277,285,277,285,285,285,285,147,147,147
,147,285,285,285,285,285,285,277,147,147,285,277,285,285,285,147,147,147
,147,285,285,277,147,285,285,285,285,277,285,285,285,285,277,285,277,277
,285,285,285,285,285,277,285,285,285,285,285,285,285,285,277,285,285,285
,285,277,285,285,285,285,285,285,285,277,84,285,285,285,285,277,285,285
,277,285,277,277,277,277,277,277,277,84,285,285,285,84,285,277,285,285,285
,285,285,285,285,84,285,285,285,285,285,84,285,285,285,285,84,285,84,84
,285,285,285,285,285,84,285,285,285,285,285,285,285,285,84,84,285,285,285
,84,285,285,285,285,285,285,285,84,39,285,285,285,285,84,285,285,84,285
,84,84,84,84,84,84,84,39,285,285,285,39,285,84,285,285,285,285,285,39,285
,39,285,285,285,285,285,39,285,285,285,285,39,285,39,39,285,285,285,285
,285,39,285,285,285,285,285,285,285,285,39,285,285,285,285,39,285,285,285
,285,285,285,285,39,79,285,285,285,285,39,285,285,39,285,39,39,39,39,39
,39,39,79,285,285,285,79,285,39,285,285,285,285,285,285,285,79,285,285,285
,285,285,79,285,285,285,285,79,285,79,79,285,285,285,285,285,79,285,285
,285,285,285,285,285,285,79,285,285,285,285,79,285,285,285,285,285,285,285
,79,62,285,285,285,285,79,285,285,79,285,79,79,79,79,79,79,79,62,285,285
,285,62,285,79,285,285,285,285,285,285,285,62,285,285,285,285,285,62,285
,285,285,285,62,285,62,62,285,285,285,285,285,62,285,285,285,285,285,285
,285,285,62,285,285,285,285,62,285,285,285,285,285,285,285,62,164,285,285
,285,285,62,285,285,62,285,62,62,62,62,62,62,62,164,285,285,285,164,285
,62,285,285,285,285,285,285,285,164,285,285,285,285,285,164,285,285,285
,285,164,285,164,164,285,285,285,285,285,164,285,285,285,285,285,285,285
,285,164,285,285,285,285,164,285,285,285,285,285,285,285,164,27,285,285
,285,285,164,285,285,164,285,164,164,164,164,164,164,164,27,285,285,285
,27,285,164,285,285,285,285,285,285,285,27,285,285,285,285,285,27,285,285
,285,285,27,285,27,27,285,285,285,285,285,27,285,285,285,285,285,285,285
,285,27,285,285,285,285,27,285,285,285,285,285,285,285,27,166,285,285,285
,285,27,285,285,27,285,27,27,27,27,27,27,27,166,285,285,285,166,285,27,285
,285,285,285,285,285,285,166,285,285,285,285,285,166,285,285,285,285,166
,285,166,166,285,285,285,285,285,166,285,285,285,285,285,285,285,285,166
,285,285,285,285,166,285,285,285,285,285,285,285,166,201,285,285,285,285
,166,285,285,166,285,166,166,166,166,166,166,166,201,285,285,285,201,285
,166,285,285,285,285,285,285,285,201,285,285,285,285,285,201,285,285,285
,285,201,285,201,201,285,285,285,285,285,201,285,285,285,285,285,285,285
,285,201,285,285,285,285,201,285,285,285,285,285,285,285,201,203,285,285
,285,285,201,285,285,201,285,201,201,201,201,201,201,201,203,285,285,285
,203,285,201,285,285,285,285,285,285,285,203,285,285,285,285,285,203,285
,285,285,285,203,285,203,203,285,285,285,285,285,203,285,285,285,285,285
,285,285,285,203,285,285,285,285,203,285,285,285,285,285,285,285,203,252
,285,285,285,285,203,285,285,203,285,203,203,203,203,203,203,203,252,285
,285,285,252,285,203,285,285,285,285,285,285,285,252,285,285,285,285,285
,252,285,285,285,285,252,285,252,252,285,285,285,285,285,252,285,285,285
,285,285,285,285,285,252,285,285,285,285,252,285,285,285,285,285,285,285
,252,87,285,285,285,285,252,285,285,252,285,252,252,252,252,252,252,252
,87,285,285,285,87,285,252,285,285,285,285,285,285,285,87,285,285,285,285
,285,87,285,285,285,285,87,285,87,87,285,285,285,285,285,87,285,285,285
,285,285,285,285,285,87,285,285,285,285,87,285,285,285,285,285,285,285,87
,144,285,285,285,285,87,285,285,87,285,87,87,87,87,87,87,87,144,285,285
,285,144,285,87,285,285,285,285,285,285,285,144,285,285,285,285,285,144
,285,285,285,285,144,285,144,144,285,285,285,285,285,144,285,285,285,285
,285,285,285,285,144,285,285,285,285,144,285,285,285,285,285,285,285,144
,174,285,285,285,285,144,285,285,144,285,144,144,144,144,144,144,144,174
,285,285,285,174,285,144,285,285,285,285,285,285,285,174,285,285,285,285
,285,174,285,285,285,285,174,285,174,174,285,285,285,285,285,174,285,285
,285,285,285,285,285,285,174,285,285,285,285,174,285,285,285,285,285,285
,285,174,124,285,285,285,285,174,285,285,174,285,174,174,174,174,174,174
,174,124,285,285,285,124,285,174,285,285,285,285,285,285,285,124,285,285
,285,285,285,124,285,285,285,285,124,285,124,124,285,285,285,285,285,124
,285,285,285,285,285,285,285,285,124,285,285,285,285,124,285,285,285,285
,285,285,285,124,25,285,285,285,285,124,285,285,124,285,124,124,124,124
,124,124,124,25,285,285,285,25,285,124,285,285,285,285,285,285,285,25,285
,285,285,285,285,25,285,285,285,285,25,285,25,25,285,285,285,285,285,25
,285,285,285,285,285,285,285,285,25,285,285,285,285,25,285,285,285,285,285
,285,285,25,214,285,285,285,285,25,285,285,25,285,25,25,25,25,25,25,25,214
,285,285,285,214,285,25,285,285,285,285,285,285,285,214,285,285,285,285
,285,214,285,285,285,285,214,285,214,214,285,285,285,285,285,214,285,285
,285,285,285,285,285,285,214,285,285,285,285,214,285,285,285,285,285,285
,285,214,216,285,285,285,285,214,285,285,214,285,214,214,214,214,214,214
,214,216,285,285,285,216,285,214,285,285,285,285,285,285,285,216,285,285
,285,285,285,216,285,285,285,285,216,285,216,216,285,285,285,285,285,216
,285,285,285,285,285,285,285,285,216,285,285,285,285,216,285,285,285,285
,285,285,285,216,40,285,285,285,285,216,285,285,216,285,216,216,216,216
,216,216,216,40,285,285,285,40,285,216,285,285,285,285,285,285,285,40,285
,285,285,285,285,40,285,285,285,285,40,285,40,40,285,285,285,285,285,40
,285,285,285,285,285,285,285,285,40,285,285,285,285,40,285,285,285,285,285
,285,285,40,70,285,285,285,285,40,285,285,40,285,40,40,40,40,40,40,40,70
,285,285,285,70,285,40,285,285,285,285,285,285,285,70,285,285,285,285,285
,70,285,285,285,285,70,285,70,70,285,285,285,285,285,70,285,285,285,285
,285,285,285,285,70,285,285,285,285,70,285,285,285,285,285,285,285,70,132
,285,285,285,285,70,285,285,70,285,70,70,70,70,70,70,70,132,285,285,285
,132,285,70,285,285,285,285,285,285,285,132,285,285,285,285,285,132,285
,285,285,285,132,285,132,132,285,285,285,285,285,132,285,285,285,285,285
,285,285,285,132,285,285,285,285,132,285,285,285,285,285,285,285,132,60
,285,285,285,285,132,285,285,132,285,132,132,132,132,132,132,132,60,285
,285,285,60,285,132,285,285,285,285,285,285,285,60,285,285,285,285,285,60
,285,285,285,285,60,285,60,60,285,285,285,285,285,60,285,285,285,285,285
,285,285,285,60,285,285,285,285,60,285,285,285,285,285,285,285,60,153,285
,285,285,285,60,285,285,60,285,60,60,60,60,60,60,60,153,285,285,285,153
,285,60,285,285,285,285,285,285,285,153,285,285,285,285,285,153,285,285
,285,285,153,285,153,153,285,285,285,285,285,153,285,285,285,285,285,285
,285,285,153,285,285,285,285,153,285,285,285,285,285,285,285,153,76,285
,285,285,285,153,285,285,153,285,153,153,153,153,153,153,153,76,285,285
,285,76,285,153,285,285,285,285,285,285,285,76,285,285,285,285,285,76,285
,285,285,285,76,285,76,76,285,285,285,285,285,76,285,285,285,285,285,285
,285,285,76,285,285,285,285,76,285,285,285,285,285,285,285,76,156,285,285
,285,285,76,285,285,76,285,76,76,76,76,76,76,76,156,285,285,285,156,285
,76,285,285,285,285,285,285,285,156,285,285,285,285,285,156,285,285,285
,285,156,285,156,156,285,285,285,285,285,156,285,285,285,285,285,285,285
,285,156,285,285,285,285,156,285,285,285,285,285,285,285,156,279,285,285
,285,285,156,285,285,156,285,156,156,156,156,156,156,156,279,285,285,285
,279,285,156,285,285,285,285,285,285,285,279,285,285,285,285,285,279,285
,285,285,285,279,285,279,279,285,285,285,285,285,279,285,285,285,285,285
,285,285,285,279,285,285,285,285,279,285,285,285,285,285,285,285,279,280
,285,285,285,285,279,285,285,279,285,279,279,279,279,279,279,279,280,285
,285,285,280,285,279,285,285,285,285,285,285,285,280,285,285,285,285,285
,280,285,285,285,285,280,285,280,280,285,285,285,285,285,280,285,285,285
,285,285,285,285,285,280,285,285,285,285,280,285,285,285,285,285,285,285
,280,158,285,285,285,285,280,285,285,280,285,280,280,280,280,280,280,280
,158,285,285,285,158,285,280,285,285,285,285,285,285,285,158,285,285,285
,285,285,158,285,285,285,285,158,285,158,158,285,285,285,285,285,158,285
,285,285,285,285,285,285,285,158,285,285,285,285,158,285,285,285,285,285
,285,285,158,159,285,285,285,285,158,285,285,158,285,158,158,158,158,158
,158,158,159,285,285,285,159,285,158,285,285,285,285,285,285,285,159,285
,285,285,285,285,159,285,285,285,285,159,285,159,159,285,285,285,285,285
,159,285,285,285,285,285,285,285,285,159,285,285,285,285,159,285,285,285
,285,285,285,285,159,285,285,285,285,285,159,285,285,159,285,159,159,159
,159,159,159,159,285,285,285,285,285,285,159,285,285,285,285,285}
,
{253,0,1041,4385,361,310,6474,6696,5938,278,1685,209,2057,4790,1592,272
,875,1964,3,0,6139,580,6214,6289,269,10122,312,9456,2243,183,4873,2336,313
,2429,2615,2708,161,2801,2957,9160,10344,6364,344,359,362,377,390,392,71
,395,339,400,377,6,5714,49,227,5789,675,307,10566,311,9308,222,276,3050
,55,6064,8541,384,10418,29,393,1220,107,376,10714,110,409,9234,410,1313
,242,37,9086,3,270,9826,1406,25,7743,5350,116,303,312,331,8836,6436,322
,1499,4993,7014,295,374,7418,737,384,7779,642,146,1778,91,8872,5548,1871
,7,6857,5449,327,7028,3455,17,40,104,10048,196,7522,7650,3377,7937,3801
,7615,10492,988,7972,8393,3533,579,8615,8743,3218,4790,8136,8708,9900,4307
,381,8944,451,2150,44,6821,1123,10640,3689,136,10788,401,11010,11084,3836
,423,7177,5864,9382,3611,9530,34,283,24,7582,173,285,74,9974,288,5061,4970
,194,286,279,7847,327,158,5485,8103,3768,370,5413,155,2522,45,8800,5132
,547,5643,5683,5227,5267,5326,200,9604,159,9678,0,674,1287,319,6925,416
,819,900,7102,4701,10196,137,10270,193,35,160,120,121,7251,777,52,143,7325
,235,4272,5720,4508,7382,3297,7454,2877,6587,1063,271,7707,82,269,3915,3996
,7904,4077,8046,4474,33,328,262,8171,361,9752,2801,1196,320,8245,380,8319
,4549,8467,387,21,343,1018,5996,4158,335,8675,4239,333,3143,6519,4386,8908
,6658,359,9012,417,10862,10936,4623,6764,427,430}
,
{
{{42,42}
,{1,1}
,{87,87}
,{61,61}
,{57,57}
,{4,4}
,{1,1}
,{1,1}
,{71,71}
,{4,4}
,{63,63}
,{4,4}
,{63,63}
,{4,4}
,{63,63}
,{4,4}
,{57,57}
,{63,63}
,{63,63}
,{4,4}
,{71,71}
,{57,57}
,{71,71}
,{71,71}
,{24,24}
,{2,2}
,{24,24}
,{2,2}
,{63,63}
,{8,8}
,{4,4}
,{63,63}
,{17,17}
,{63,63}
,{63,63}
,{63,63}
,{32,32}
,{63,63}
,{63,63}
,{2,2}
,{2,2}
,{71,71}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{63,63}
,{4,4}
,{45,45}
,{4,4}
,{71,71}
,{4,4}
,{4,4}
,{71,71}
,{57,57}
,{4,4}
,{2,2}
,{4,4}
,{2,2}
,{67,67}
,{67,67}
,{63,63}
,{4,4}
,{71,71}
,{2,2}
,{4,4}
,{2,2}
,{4,4}
,{4,4}
,{63,63}
,{4,4}
,{24,24}
,{2,2}
,{4,4}
,{4,4}
,{2,2}
,{17,17}
,{63,63}
,{4,4}
,{73,73}
,{63,63}
,{4,4}
,{4,4}
,{2,2}
,{63,63}
,{51,51}
,{45,45}
,{30,30}
,{30,30}
,{30,30}
,{22,22}
,{4,4}
,{45,45}
,{30,30}
,{23,23}
,{63,63}
,{48,48}
,{30,30}
,{81,81}
,{4,4}
,{45,45}
,{5,5}
,{6,6}
,{45,45}
,{5,5}
,{30,30}
,{63,63}
,{51,51}
,{45,45}
,{30,30}
,{63,63}
,{51,51}
,{45,45}
,{30,30}
,{103,103}
,{2,2}
,{42,42}
,{4,4}
,{4,4}
,{63,63}
,{2,2}
,{4,4}
,{103,103}
,{2,2}
,{42,42}
,{18,18}
,{18,18}
,{18,18}
,{2,2}
,{18,18}
,{103,103}
,{2,2}
,{42,42}
,{18,18}
,{103,103}
,{2,2}
,{42,42}
,{18,18}
,{18,18}
,{18,18}
,{2,2}
,{42,42}
,{6,6}
,{45,45}
,{2,2}
,{63,63}
,{20,20}
,{45,45}
,{42,42}
,{2,2}
,{42,42}
,{5,3}
,{2,2}
,{4,4}
,{2,2}
,{2,2}
,{42,42}
,{5,5}
,{2,2}
,{4,4}
,{2,2}
,{2,2}
,{2,2}
,{33,33}
,{71,71}
,{48,48}
,{45,45}
,{2,2}
,{71,71}
,{16,16}
,{2,2}
,{8,8}
,{2,2}
,{2,2}
,{30,30}
,{30,30}
,{42,42}
,{4,4}
,{4,4}
,{30,30}
,{22,22}
,{45,45}
,{18,18}
,{45,45}
,{30,30}
,{30,30}
,{63,63}
,{48,48}
,{45,45}
,{30,30}
,{22,22}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{4,4}
,{30,30}
,{2,2}
,{30,30}
,{2,2}
,{30,3}
,{18,18}
,{30,30}
,{93,93}
,{4,4}
,{4,4}
,{18,18}
,{18,18}
,{2,2}
,{18,18}
,{2,2}
,{17,3}
,{2,2}
,{4,4}
,{4,4}
,{30,30}
,{30,30}
,{44,44}
,{4,4}
,{18,18}
,{30,30}
,{71,71}
,{4,4}
,{4,4}
,{18,18}
,{18,18}
,{18,18}
,{45,45}
,{18,18}
,{45,45}
,{18,18}
,{2,2}
,{18,18}
,{51,51}
,{45,45}
,{2,2}
,{63,63}
,{18,18}
,{18,18}
,{45,45}
,{18,18}
,{2,2}
,{18,18}
,{30,30}
,{30,30}
,{100,100}
,{4,4}
,{4,4}
,{2,2}
,{18,18}
,{30,30}
,{59,59}
,{4,4}
,{4,4}
,{2,2}
,{18,18}
,{63,63}
,{4,4}
,{52,52}
,{52,52}
,{18,18}
,{45,45}
,{18,18}
,{63,63}
,{45,45}
,{18,18}
,{68,68}
,{63,63}
,{45,45}
,{18,18}
,{45,45}
,{30,30}
,{60,60}
,{4,4}
,{4,4}
,{2,2}
,{2,2}
,{42,42}
,{4,4}
,{4,4}
,{4,4}
}
,
{16,0,0,0,0,0,0,0,0,0,0,0,0}
,
{0,0,0,2,0,56,0,30,1,192,0,6,13}
,
{40,0,0,0,0,0,0,1,0,0,0,0,0}
}
};


/* Non terminal table *\
\* ------------------ */
typedef  struct {
    UByte2 gto[1289];		/* Goto table */
    UByte2 gtoRix[285];		/* Goto row mapping */
    UByte1 lhs[306];		/* Left hand side symbols */
    UByte1 rhsz[306];		/* Size of the RHS */
} NonTermTab;

static NonTermTab gto = {
{161,394,1177,74,154,130,321,1986,1026,1409,1882,249,33,1177,194,186,674
,345,985,1042,1345,985,146,170,313,2265,1786,2210,90,2002,82,154,130,330
,129,138,122,162,1114,178,10,194,186,985,322,1897,42,321,177,146,170,418
,1537,2186,985,90,298,1249,1009,1898,1433,1138,138,122,162,313,178,1713
,2201,2033,1714,321,394,114,1441,161,817,137,722,1793,1169,98,153,1009,386
,1882,249,1433,1394,313,2002,666,1977,1649,1009,2201,2033,842,985,881,114
,1786,106,969,985,857,1793,1985,98,129,698,1722,1634,1818,1681,145,490,1905
,137,2210,1649,1386,1914,177,1473,1513,1521,1537,1386,106,458,370,65,1329
,1985,985,586,602,1009,985,1442,1426,137,1609,1009,1634,857,2081,290,1249
,1402,985,1634,1033,1410,378,1122,153,1145,1361,1386,2265,2210,1313,785
,1642,745,985,1434,1450,1810,1418,1386,1442,1426,977,849,1473,1769,1138
,1442,1426,34,1402,1634,1241,1849,1410,2257,618,1402,1009,1641,985,1410
,1386,1634,1914,1642,873,1097,1434,1450,1362,1418,1642,985,1009,1434,1450
,161,1418,1442,1426,1082,1297,1129,1058,1042,1634,1882,2186,1402,1841,1442
,1426,1410,1386,2002,1986,482,913,1386,977,1402,1905,945,1642,1410,449,1434
,1450,17,1418,1834,2186,977,1442,1426,1642,2002,1634,1434,1450,1761,1418
,1634,1402,177,1986,1705,1410,1345,778,1386,754,770,2210,1193,473,609,1986
,1642,1289,354,1434,1450,1753,1418,1442,1426,553,826,609,1442,1426,2274
,1386,1634,1402,1425,1225,153,1410,1402,2002,1218,1729,1410,1386,561,1297
,609,1377,1642,25,1825,1434,1450,1642,1418,1634,1434,1450,1986,1418,1442
,1426,457,1433,1314,746,1993,1634,2258,329,1402,2186,1841,985,1410,1386
,1914,2186,985,1497,714,2274,1386,1442,1426,1642,737,570,1434,1450,970,1418
,2194,1402,1073,1442,1426,1410,1386,1634,2121,698,1553,753,362,1402,1634
,521,1642,1410,689,1434,1450,977,1418,2186,466,738,977,1986,1642,1386,1634
,1434,1450,1697,1418,1442,1426,2026,1986,985,2017,1153,1442,1426,577,1402
,2065,2002,2034,1410,2186,1386,1402,1634,1489,1865,1410,625,1442,1426,1642
,2113,985,1434,1450,1938,1418,1642,1402,2097,1434,1450,1410,1418,1386,1634
,649,626,1881,977,1842,1442,1426,1642,1465,585,1434,1450,1946,1418,1386
,1402,993,258,1921,1410,1041,1386,1634,481,1066,1945,977,1442,1426,329,1642
,401,1986,1434,1450,2233,1418,1402,1634,1049,1074,1410,81,2041,610,1634
,1625,633,497,1657,1442,1426,1642,1386,1057,1434,1450,1961,1418,1265,1402
,1386,1322,2218,1410,2137,1442,1426,513,1954,2202,1105,1745,1442,1426,1642
,1402,1634,1434,1450,1410,1418,697,1402,1762,1634,49,1410,1801,1194,1137
,1642,401,2273,1434,1450,1386,1418,1642,0,2161,1434,1450,0,1418,1442,1426
,0,1386,0,0,0,2193,1442,1426,1402,0,0,0,1410,1634,0,0,1402,0,0,0,1410,0
,0,1642,1386,1634,1434,1450,2209,1418,0,1642,0,0,1434,1450,1394,1418,0,0
,0,1442,1426,0,1186,0,0,0,1634,0,0,1402,0,1442,1426,1410,1394,0,0,0,1634
,0,0,1402,0,0,1642,1410,1394,1434,1450,0,1418,0,0,0,1442,1426,1642,0,1634
,1434,1450,0,1418,0,1402,0,1442,1426,1410,1394,1634,0,0,0,0,0,1402,0,0,1642
,1410,1394,1434,1450,0,1418,1442,1426,0,1394,0,1642,0,1634,1434,1450,1402
,1418,1442,1426,1410,1394,0,0,0,1634,0,0,1402,0,0,1642,1410,1634,1434,1450
,0,1418,0,0,0,1442,1426,1642,1394,1634,1434,1450,0,1418,0,1402,0,1442,1426
,1410,1394,0,0,0,0,1442,1426,1402,1394,0,1642,1410,1634,1434,1450,1402,1418
,1442,1426,1410,1394,0,1642,0,1634,1434,1450,1402,1418,0,1642,1410,1634
,1434,1450,0,1418,0,0,0,1442,1426,1642,1394,1634,1434,1450,0,1418,0,1402
,0,1442,1426,1410,1394,0,0,0,0,1442,1426,1402,1394,0,1642,1410,1634,1434
,1450,1402,1418,1442,1426,1410,1394,0,1642,0,1634,1434,1450,1402,1418,0
,1642,1410,1634,1434,1450,0,1418,0,0,0,1442,1426,1642,1394,1634,1434,1450
,0,1418,0,1402,0,1442,1426,1410,1394,0,0,0,0,1442,1426,1402,1394,0,1642
,1410,1634,1434,1450,1402,1418,1442,1426,1410,1394,0,1642,0,1634,1434,1450
,1402,1418,0,1642,1410,1634,1434,1450,0,1418,0,0,0,1442,1426,1642,1394,1634
,1434,1450,0,1418,0,1402,0,1442,1426,1410,1394,0,0,0,0,1442,1426,1402,1394
,0,1642,1410,1634,1434,1450,1402,1418,1442,1426,1410,0,0,1642,0,1634,1434
,1450,1402,1418,0,1642,1410,1634,1434,1450,0,1418,0,0,0,1442,1426,1642,0
,0,1434,1450,0,1418,0,1402,0,1442,1426,1410,0,0,0,0,0,1442,1426,1402,0,1969
,1642,1410,906,1434,1450,1402,1418,0,0,1410,0,161,1642,0,0,1434,1450,0,1418
,0,1642,1882,249,1434,1450,0,1418,0,0,2073,161,882,1266,0,0,0,0,1786,0,161
,1882,249,890,0,0,129,0,0,0,1882,249,866,0,1274,0,0,1786,0,1433,177,874
,0,834,929,129,1786,161,0,0,161,0,0,0,129,0,161,1882,249,177,1882,113,1242
,665,0,1210,1882,249,177,1433,0,1250,721,1786,153,0,1786,0,0,0,0,129,1786
,0,129,858,0,0,0,0,129,0,0,153,0,177,0,0,177,97,161,0,153,0,177,161,1234
,0,241,0,1882,249,0,0,1914,1882,249,0,0,0,0,0,0,0,0,161,1786,0,0,153,0,1786
,153,1914,129,1882,249,161,153,129,0,0,1914,0,0,0,0,1882,177,0,161,1786
,2185,177,0,161,0,1209,161,129,1882,249,0,1794,0,1882,0,0,1882,1914,161
,129,1914,177,0,0,1786,897,1914,0,1882,1850,153,161,129,177,0,153,0,129
,0,161,265,1882,249,0,297,0,177,0,161,1882,537,177,129,0,177,153,0,1786
,1882,0,0,0,0,0,0,129,177,153,161,0,1914,0,0,1922,1858,1914,161,0,1882,177
,153,0,129,601,0,153,1882,177,153,0,0,0,0,0,0,1914,177,0,0,0,153,0,1826
,0,0,0,0,1914,0,0,809,0,0,153,0,0,177,0,0,0,1914,153,0,0,177,1914,0,0,1914
,0,153,0,0,0,0,0,0,0,0,0,1914,0,0,0,0,0,0,0,0,0,153,0,0,1914,0,0,0,0,153
,0,0,1914,0,0,0,0,0,0,0,0,1914,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1914
,0,0,0,0,0,0,0,1914}
,
{204,22,0,27,492,11,82,686,456,11,985,11,988,11,1075,70,95,210,11,11,314
,41,375,386,11,413,11,436,994,10,10,1096,10,1129,1093,1108,10,1138,1158
,381,493,7,10,10,10,10,10,10,407,9,9,9,9,9,229,232,9,259,429,9,472,8,492
,277,7,1088,7,271,253,6,270,317,6,1121,5,5,283,355,4,302,3,949,3,3,286,388
,3,508,958,3,292,42,242,3,3,2,114,576,2,1166,5,46,2,2,126,796,2,149,631
,2,1063,2,181,741,930,2,186,541,2,54,387,2,358,2,441,2,444,104,410,377,391
,11,348,494,495,151,135,0,514,167,193,72,302,210,13,2,2,218,596,1043,1,241
,651,119,27,1,483,1,487,215,301,1,72,1,20,1,262,1,127,1,253,706,13,1,9,1
,171,10,32,300,1,371,1,351,327,285,761,75,816,1,0,0,308,553,0,0,0,0,0,346
,363,470,85,162,0,397,259,0,53,0,331,588,18,206,267,0,496,162,0,104,0,0
,221,449,917,0,245,0,129,91,124,353,608,376,643,21,139,0,392,663,0,399,698
,431,718,43,329,234,359,0,327,0,464,412,947,0,333,0,98,334,337,0,284,311
,477,439,753,0,474,773,0,1038,486,808,509,521,0,398,0,513,161,25,517,0,0
}
,
{143,206,206,132,132,126,126,126,117,117,108,108,108,108,108,108,108,108
,108,108,108,108,108,108,133,207,186,178,154,154,145,145,145,145,140,171
,171,134,141,172,172,136,127,163,163,164,196,196,188,188,224,224,146,146
,235,235,218,218,215,137,137,208,208,208,208,208,208,208,189,189,109,165
,147,147,216,216,210,209,148,197,197,197,156,156,121,179,179,111,142,198
,181,181,219,219,219,219,219,182,190,190,112,220,220,128,184,168,168,211
,211,211,211,211,211,169,225,225,106,106,106,230,230,167,167,138,138,149
,183,183,192,192,113,158,144,212,193,194,199,199,129,129,122,201,201,200
,200,195,195,119,173,159,120,174,160,160,202,202,202,202,202,161,233,233
,130,150,150,114,114,114,110,118,226,226,155,155,151,151,151,151,151,151
,151,213,213,213,213,217,217,217,217,217,217,217,217,234,234,204,204,231
,231,231,231,221,221,232,232,175,229,229,162,162,222,222,228,176,176,170
,170,203,223,223,157,157,116,116,131,131,205,205,205,205,205,205,139,139
,139,139,139,139,139,139,153,153,153,152,115,115,115,115,191,191,123,123
,123,123,124,124,124,124,125,125,125,125,125,125,125,180,180,180,180,177
,177,166,166,107,107,135,135,214,214,187,187,227,185,185,105,105,105,105
,105,105,105,105,105,105,105,105,105,105,105,105,105,105,105,105,105,105
}
,
{3,0,2,1,2,2,3,3,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,2,3,1,2,3,2,2,1
,2,4,2,1,2,3,2,1,2,4,1,2,1,4,0,2,1,1,1,2,1,3,5,1,3,1,1,1,1,1,2,2,0,2,3,2
,1,1,1,2,3,2,4,0,2,2,1,3,3,0,1,3,3,3,0,2,1,1,2,1,1,4,0,2,6,0,5,3,5,0,2,1
,1,1,1,2,1,4,0,3,1,1,1,0,1,1,2,1,2,2,0,1,0,2,2,2,3,2,3,4,0,2,1,2,3,1,2,0
,2,0,2,3,2,4,3,5,0,2,1,1,2,1,1,4,0,2,5,1,2,2,4,5,4,4,0,1,1,2,1,1,1,1,1,1
,1,1,3,3,3,2,2,2,2,2,3,3,3,4,4,3,6,4,4,4,5,0,2,1,1,9,0,1,4,5,0,2,7,1,2,2
,3,5,0,2,1,3,1,3,1,2,2,2,3,2,3,5,2,1,1,1,2,3,1,4,1,3,3,2,1,1,1,1,0,1,1,1
,2,2,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,0,1,1,2,1,3,0,1,0,1,3,1,1,1,1,1,1
,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
};


/* Vocabulary *\
\* ---------- */
typedef struct {
    UByte1 scc;			/* Scanner code value */
    UByte1 iCost;		/* Insertion cost */
    UByte1 dCost;		/* Deletion cost */
    char *name;			/* Name string */
    char *psym;			/* Print name */
} VocTab[104];
			     
static VocTab voc = {{1,255,255,"EndOfText",""}
,{2,1,1,"IDENT","Identifier"}
,{3,1,1,"','",""}
,{4,1,1,"'.'",""}
,{5,1,1,"'='",""}
,{6,1,1,"':'",""}
,{7,1,1,"'('",""}
,{8,1,1,"')'",""}
,{9,1,1,"'*'",""}
,{10,1,1,"'!'",""}
,{11,1,1,"'+'",""}
,{12,1,1,"'-'",""}
,{13,1,1,"'/'",""}
,{14,1,1,"'>'",""}
,{15,1,1,"'<'",""}
,{16,1,1,"'OR'",""}
,{17,1,1,"'TO'",""}
,{18,1,1,"'IS'",""}
,{19,1,1,"'IN'",""}
,{20,1,1,"'=>'",""}
,{21,1,1,"'BY'",""}
,{22,1,1,"'IF'",""}
,{23,1,1,"'ON'",""}
,{24,1,1,"'OF'",""}
,{25,1,1,"'AT'",""}
,{26,1,1,"'<>'",""}
,{27,1,1,"'=='",""}
,{28,1,1,"'>='",""}
,{29,1,1,"'<='",""}
,{30,1,1,"'END'",""}
,{31,1,1,"'NOT'",""}
,{32,1,1,"'AND'",""}
,{33,1,1,"'ISA'",""}
,{34,1,1,"'ARE'",""}
,{35,1,1,"'HAS'",""}
,{36,1,1,"'SAY'",""}
,{37,1,1,"'SET'",""}
,{38,1,1,"'USE'",""}
,{39,1,1,"'FOR'",""}
,{40,1,1,"'SUM'",""}
,{41,1,1,"'MAX'",""}
,{42,1,1,"'VERB'",""}
,{43,1,1,"'DOES'",""}
,{44,1,1,"'EXIT'",""}
,{45,1,1,"STRING",""}
,{46,1,1,"'QUIT'",""}
,{47,1,1,"'SAVE'",""}
,{48,1,1,"'ELSE'",""}
,{49,1,1,"'WHEN'",""}
,{50,1,1,"'NAME'",""}
,{51,1,1,"'THEN'",""}
,{52,1,1,"'STEP'",""}
,{53,1,1,"'WAIT'",""}
,{54,1,1,"'LIST'",""}
,{55,1,1,"'LOOK'",""}
,{56,1,1,"'MAKE'",""}
,{57,1,1,"'HERE'",""}
,{58,1,1,"'ONLY'",""}
,{59,1,1,"'ACTOR'",""}
,{60,1,1,"'EVENT'",""}
,{61,1,1,"'START'",""}
,{62,1,1,"'CHECK'",""}
,{63,1,1,"Integer",""}
,{64,1,1,"'WHERE'",""}
,{65,1,1,"'EMPTY'",""}
,{66,1,1,"'COUNT'",""}
,{67,1,1,"'AFTER'",""}
,{68,1,1,"'UNTIL'",""}
,{69,1,1,"'SCORE'",""}
,{70,1,1,"'ELSIF'",""}
,{71,1,1,"'OBJECT'",""}
,{72,1,1,"'SYNTAX'",""}
,{73,1,1,"'SCRIPT'",""}
,{74,1,1,"'STRING'",""}
,{75,1,1,"'LIMITS'",""}
,{76,1,1,"'HEADER'",""}
,{77,1,1,"'VISITS'",""}
,{78,1,1,"'SYSTEM'",""}
,{79,1,1,"'LOCATE'",""}
,{80,1,1,"'CANCEL'",""}
,{81,1,1,"'DEPEND'",""}
,{82,1,1,"'RANDOM'",""}
,{83,1,1,"'NEARBY'",""}
,{84,1,1,"'BEFORE'",""}
,{85,1,1,"'OPTIONS'",""}
,{86,1,1,"'MESSAGE'",""}
,{87,1,1,"'DEFAULT'",""}
,{88,1,1,"'RESTART'",""}
,{89,1,1,"'RESTORE'",""}
,{90,1,1,"'INTEGER'",""}
,{91,1,1,"'ARTICLE'",""}
,{92,1,1,"'BETWEEN'",""}
,{93,1,1,"'LOCATION'",""}
,{94,1,1,"'SYNONYMS'",""}
,{95,1,1,"'DESCRIBE'",""}
,{96,1,1,"'SCHEDULE'",""}
,{97,1,1,"'INCREASE'",""}
,{98,1,1,"'DECREASE'",""}
,{99,1,1,"'CONTAINS'",""}
,{100,1,1,"'CONTAINER'",""}
,{101,1,1,"'MENTIONED'",""}
,{102,1,1,"'DEPENDING'",""}
,{103,1,1,"'ATTRIBUTES'",""}
,{104,1,1,"'DESCRIPTION'",""}
}
;


/* Variables used in the parsing process *\
\* ------------------------------------- */
short pmStkP;			/* Stack pointer */
Token pmSySt[PmStkMax];	/* Symbol stack */
pmGrammar pmSeSt[PmStkMax];	/* Semantic stack */ 
static UByte2 currstat;		/* Current state number */
static UByte2 arg;		/* Argument */
static UByte1 action;		/* Action type */
static PmBoolean endparse;	/* Termination flag */
static ParseStack parsStk;	/* Parse stack */
static UByte1 scIndex[104 + 1]; /* Converts scanner code to internal value */
static Token tokenBuf;	/* Scanner token buffer */
static Token *token = &tokenBuf;	/* Pointer to it for readsymb */


/* Error recovery look-ahead buffer *\
\* -------------------------------- */
static Token la_buff[PmLaMax + 1]; /* Buffer */
static int la_ptr;		/* Current pointer */
static int la_end;		/* Last item */

static jmp_buf pmJmpB;		/* Buffer for long jump */

/* Interface routines *\
\* ------------------ */

extern void pmRPoi(	/* Error recovery - restart point  */
Token *sym			/* IN the restart symbol */
);
extern void pmISym(	/* Error recovery - insert symbol  */
int code,			/* IN terminal code number */
char *sstr,			/* IN terminal string */
char *pstr,			/* IN the terminals print symbol */
Token *sym			/* OUT the created scanner symbol */
);
extern void pmDSym(	/* Error recovery - delete symbol  */
Token *sym,			/* IN terminal code number */
char *sstr,			/* IN terminal string */
char *pstr			/* IN terminals print string */
);
extern void pmMess(	/* Error recovery - error message  */
Token *sym,			/* IN error token */
int method,			/* IN recovery method */
int code,			/* IN error classification */
int severity			/* IN error severity code */
);

/* External functions */
extern void pmPaSema(
int rule			/* IN production number */
);

/*----------------------------------------------------------------------------
 * paAbort - Abort the parsing process
 *----------------------------------------------------------------------------
 */
static void paAbort(
Token *token,		/* IN current token */
short eClass,			/* IN error classification */
short severity			/* IN error severity code */
)
{
    pmMess(token, HALT_REC, eClass, severity);
    longjmp(pmJmpB, PMTRUE);	/* Jump out to top level */
}/*paAbort()*/


/*----------------------------------------------------------------------------
 * SetIns - Add one element to a set
 *----------------------------------------------------------------------------
 */
#define SetIns(set, n) ((set)[(n) >> 3] |= (0x80 >> ((n) & 0x7)))


/*----------------------------------------------------------------------------
 * SetClear - Clear a ParserMaker set
 *----------------------------------------------------------------------------
 */
#define SetClear(set, length) memset((void *)set, 0, (size_t)((length) + 7) >> 3)

/*----------------------------------------------------------------------------
 * SetMem - Check member inclusion
 *----------------------------------------------------------------------------
 */
#define SetMem(set, n) ((set)[(n) >> 3] & (0x80 >> ((n) & 0x7)))


/*----------------------------------------------------------------------------
 * paInit - Initialize the parsing process
 *----------------------------------------------------------------------------
 */
static void paInit(void)
{
    short i;

    la_ptr = 0;
    la_end = 0;
    pmStkP = 0;
    currstat = 1;
    endparse = PMFALSE;
    parsStk[0] = 1;

    /* Scanner interface */
    for (i = 0; i <= SccMax; i++) scIndex[i] = ERR_SYM;
    for (i = TermMin; i <= Terms; i++) scIndex[voc[i - TermMin].scc] = (UByte1)i;
}/*paInit()*/


/*----------------------------------------------------------------------------
 * pushStat[Tok] - Push the current state on the stack and possibly push current
 *	      token on the symbol stack.
 *----------------------------------------------------------------------------
 */
#define MOVETOKEN pmSySt[pmStkP] = *token
#define pushStatTok()\
{\
    if (++pmStkP < PmStkMax) {\
	parsStk[pmStkP] = currstat;\
	MOVETOKEN;\
    } else {\
	token->code = voc[token->code-TermMin].scc;\
	paAbort(token, OFLW_ERR, SYS_SEV);\
    }\
} 

#define pushStat()\
{\
    if (++pmStkP < PmStkMax) {\
	parsStk[pmStkP] = currstat;\
    } else {\
	token->code = voc[token->code-TermMin].scc;\
	paAbort(token, OFLW_ERR, SYS_SEV);\
    }\
} 



/*----------------------------------------------------------------------------
 * actTbl - Do a look-up in the action table
 *----------------------------------------------------------------------------
 */
#define actTbl(st, sy, action, arg)\
{\
    register int actEnt;\
    register int actSt;\
    register int actSy;\
    actSt = st - StateMin;\
    actSy = sy - TermMin;\
    if (act.actCheck[act.actRix[actSt] + actSy] == actSt)\
	actEnt = act.act[act.actRix[actSt] + actSy];\
    else actEnt = ERROR_ACT;\
    *action = actEnt & 0x7;\
    *arg = actEnt >> 3;\
}/*actTbl()*/


/*----------------------------------------------------------------------------
 * gtoTbl - Do a look-up in the goto table
 *----------------------------------------------------------------------------
 */
#define gtoTbl(st, sy, action, arg)\
{\
    register int gtoEnt;\
    register int gtoSt;\
    register int gtoSy;\
    gtoSt = st - StateMin;\
    gtoSy = sy - Terms - 1;\
	gtoEnt = gto.gto[gto.gtoRix[gtoSt] + gtoSy];\
    *action = gtoEnt & 0x7;\
    *arg = gtoEnt >> 3;\
}/*gtoTbl()*/


/*----------------------------------------------------------------------------
 * E R R O R   R E C O V E R Y
 * ---------------------------
 *
 * The error recovery algorithm tries to modify current configuration in such
 * a way that parsing can be resumed correctly. Current configuration is
 * characterized by:
 *
 * w = x t y, where  x = parsed input
 *		     t = current token
 *		     y = unprocessed input
 *----------------------------------------------------------------------------
 */

typedef struct {
    Token err_tok;
    Token res_tok;
    short method;
    short eClass;
    short severity;
} ERR_REC;

static ERR_REC errdescr; 


/*----------------------------------------------------------------------------
 * ePush - Push a state during error recovery
 *----------------------------------------------------------------------------
 */
static void ePush(
UByte2 state,			/* IN state to push */
UByte2 stack[],			/* INOUT parser stack */
short *sp			/* INOUT current stack pointer */
)
{
    if (++(*sp) < PmStkMax) stack[*sp] = state;
    else paAbort(&errdescr.err_tok, OFLW_ERR, SYS_SEV);
}/*ePush()*/


/*----------------------------------------------------------------------------
 * legalAct - Check if a symbol is legal to shift in current state
 *----------------------------------------------------------------------------
 */
static PmBoolean legalAct(
UByte2 stack[],			/* IN current stack */
short stack_p,			/* IN current stack pointer */
UByte1 sym			/* IN symbol code */
)				/* RET true if "symbol" is read (shifted) */
				/*     in current state */
{
    UByte2 state;		/* Current state */
    UByte1 action;		/* Current parser action */
    UByte2 arg;			/* Current parser argument */

    ParseStack t_stk;		/* Temporary parser stack */
    int i;			/* For loop index */

    /* Copy stack
     */
    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i]; 

    state = stack[stack_p];

    for (;;) {
	actTbl(state, sym, &action, &arg);
	switch (action) {

	case ERROR_ACT:
	    return(PMFALSE);

	case SHIFT_ACT:
	case SHIFTRED_ACT:	
	case ACCEPT_ACT:
	    return(PMTRUE);

	case REDUCE_ACT:
	    do {
		stack_p = stack_p - gto.rhsz[arg - ProdMin];
		gtoTbl(t_stk[stack_p], gto.lhs[arg - ProdMin], &action, &arg);
		ePush(state, t_stk, &stack_p);
	    } while (action != SHIFT_ACT);
	    state = arg; t_stk[stack_p] = state;
	    break;

	}/*switch*/
    }/*for*/
}/*legalAct()*/
			     
	
/*----------------------------------------------------------------------------
 * gLegSym - Get legal symbols
 *----------------------------------------------------------------------------
 */
static void gLegSym(
ParseStack stack,		/* IN current stack */
short stack_p,			/* IN current stack pointer */
TermSet legals			/* OUT legal symbols in current state */
)
{
    short sym;			/* Loop index */

    SetClear(legals, Terms + 1);
    for (sym = 1; sym <= Terms; sym++) {
	if (legalAct(stack, stack_p, sym)) SetIns(legals, sym);
    }/*for*/
}/*gLegSym()*/


/*----------------------------------------------------------------------------
 * backup - Backup the parse stack until current symbol is accepted (shifted)
 *	    or the parse stack becomes empty
 *----------------------------------------------------------------------------
 */
static short backup(
ParseStack stack,		/* IN current stack */
short stack_p,			/* IN current stack pointer */
UByte1 sym	/* IN recovery symbol */
)				/* RET new stack pointer, 0 if symbol is */
				/*     not accepted */
{
    while ((stack_p > 0) && (!legalAct(stack, stack_p, sym))) stack_p--;
    return(stack_p);
}/*backup()*/


/*----------------------------------------------------------------------------
 * delSym - Delete a symbol in the input stream
 *----------------------------------------------------------------------------
 */
static void delSym(
Token *token			/* INOUT symbol to delete, new symbol */
)
{
    short  t;

    t = token->code - TermMin;
    token->code = voc[t].scc;
    pmDSym(token, voc[t].name, voc[t].psym);
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    if (errdescr.method == IN_REC) errdescr.method = REP_REC;
    else if (errdescr.method != REP_REC) errdescr.method = DEL_REC;
}/*delSym()*/


/*----------------------------------------------------------------------------
 * inSym - Insert a symbol in the input stream
 *----------------------------------------------------------------------------
 */
static void inSym(
short isym,			/* IN symbol code to insert */
Token *gen_symb		/* OUT created symbol */
)
{
    pmISym(voc[isym - TermMin].scc, voc[isym - TermMin].name,
	   voc[isym - TermMin].psym, gen_symb);
    if (errdescr.method == DEL_REC) errdescr.method = REP_REC;
    else if (errdescr.method != REP_REC) errdescr.method = IN_REC; 

    gen_symb->code = isym;
}/*inSym()*/


/*----------------------------------------------------------------------------
 * M U L T I P L E   R E C O V E R Y
 * ---------------------------------
 *
 * The multiple symbols recovery technique is a "true local corrector", i.e.
 * it will always return a legal configuration for any input. Logically the
 * algorithm can be described as follows:
 *
 * 1) Roerich method (Karlsruhe):
 *    a. Find a continuation "u" of "x", such that "xu" is accepted.
 *    b. De composite "ty" into "qsy'", where q is a string.
 *    c. Delete "q".
 *    d. Insert u' (a prefix of u) between "x" and "sy'" giving xu' s y'.
 *
 * 2) Panic mode:
 *    If "q" contains a fiducial symbol "a"  then:
 *    a. Pop stack until "a" is accepted.
 *    b. If not succeeded resume at step 1.
 *----------------------------------------------------------------------------
 */

typedef struct {
    UByte2 r_state;		/* Recovery state */
    PmBoolean r_sepa;		/* Insert separator? */
    UByte2 r_sstat;		/* Where to insert separator */
} REC_POI;


/*----------------------------------------------------------------------------
 * acceptbl - Check whether "symbol" is reachable from current state using
 *	      the continuation grammar.
 *----------------------------------------------------------------------------
 */
static void acceptbl(
UByte1 sym,			/* IN terminal symbol code */
ParseStack stack,		/* IN parse stack */
short stack_p,			/* IN stack pointer */
Token *token,			/* IN current token */
PmBoolean *found,		/* OUT "symbol" accepted? */
REC_POI *point			/* OUT recovery point description */
)
{
    PmBoolean done;		/* Terminator flag */
    UByte2 state;		/* Current state */
    UByte1 action;		/* Parser action */
    UByte1 sep_act;		/* Parser action separator test */
    UByte2 arg;			/* Parser prod/state */
    UByte2 sep_arg;		/* Parser prod/state separator test */
    PmBoolean sepa_acc;		/* Separator is accepted? */
    ParseStack t_stk;		/* Temporary parser stack */
    short i;			/* Copy loop index */

    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i];

    state = t_stk[stack_p];
    done = PMFALSE;

    while (!done) {
	actTbl(state, sym, &action, &arg);
	if (legalAct(t_stk, stack_p, sym)) {
	    /* Symbol is directly accepted */
	    done = PMTRUE;
	    *found = PMTRUE;
	    point->r_state = state;
	} else {
	    /* Use the continuation grammar */
	    actTbl(state, act.recover.cont[state - StateMin].tsym, &action,
		   &arg);
	    actTbl(state, act.recover.cont[state - StateMin].ssym, &sep_act,
		   &sep_arg);
	    if ((action != sep_act) || (arg != sep_arg)) {
		/* A separator is legal. Check if current symbol is accepted
		 * behind the separator
		 */
	        ParseStack stk;	/* Temporary stack */
	        short sp;	/* Temporary stack pointer */

		sp = stack_p; 
		for (i = 0; i <= stack_p; i++) stk[i] = t_stk[i];
		sepa_acc = PMFALSE;

		while (!sepa_acc) {
		  actTbl(stk[sp], act.recover.cont[state - StateMin].ssym,
			 &sep_act, &sep_arg);
		    switch (sep_act) {

		    case ERROR_ACT:
		    case ACCEPT_ACT:
			sepa_acc = PMTRUE;
			break;

		    case SHIFT_ACT: 
			sepa_acc = PMTRUE;
			ePush(sep_arg, stk, &sp);
			break;

		    case SHIFTRED_ACT:
			ePush(1, stk, &sp);
			sepa_acc = PMTRUE;
			goto reduce;

		    case REDUCE_ACT:
		      reduce:
			do {
			    sp -= gto.rhsz[sep_arg-ProdMin];
			    gtoTbl(stk[sp], gto.lhs[sep_arg-ProdMin], &sep_act,
				   &sep_arg);
			    ePush(1, stk, &sp);
			} while (sep_act != SHIFT_ACT);

			stk[sp] = sep_arg;
			break;
		    }/*switch*/
		}/*while*/

		if ((sep_act == SHIFT_ACT) || (sep_act == SHIFTRED_ACT)) {
		    if (legalAct(stk, sp, sym)) {
			/* Separator is to be inserted */
			point->r_state = stk[sp];
			point->r_sepa = PMTRUE;
			point->r_sstat = state;
			done = PMTRUE;
			*found = PMTRUE;
		    }/*if*/
		}/*if*/
	    }/*if*/
		  
	    if (!*found) {
		switch (action) {

		case ERROR_ACT: 
		    paAbort(token, TAB_ERR, SYS_SEV);
		    break;

		case ACCEPT_ACT:
		    done = PMTRUE;
		    break;

		case SHIFT_ACT:
		    state = arg;
		    ePush(state, t_stk, &stack_p);
		    break;

		case SHIFTRED_ACT:
		    ePush(state, t_stk, &stack_p);
		    goto reduce2;

		case REDUCE_ACT:
		  reduce2:
		    do {
			stack_p -= gto.rhsz[arg-ProdMin];
			gtoTbl(t_stk[stack_p], gto.lhs[arg-ProdMin], &action,
			       &arg);
			ePush(state, t_stk, &stack_p);
		    } while (action != SHIFT_ACT);

		    state = arg;
		    t_stk[stack_p] = state;
		    break;

		}/*switch*/
	    }/*if*/
	}/*if*/
    }/*while*/
}/*acceptbl()*/


/*----------------------------------------------------------------------------
 * search - Search recovery point
 *----------------------------------------------------------------------------
 */
static void search(
ParseStack stack,		/* IN current stack */
short *stack_p,			/* INOUT current stack pointer */
Token *token,			/* INOUT current symbol */
REC_POI *point			/* OUT descriptor of where to restart */
				/*     the parser */
)
{
    UByte2 state;		/* Current state */
    PmBoolean rp_found;		/* Recovery point found? */
    short new_stkp;		/* Temp stack pointer */

    state = stack[*stack_p];
    point->r_state = state;
    point->r_sepa = PMFALSE;
    point->r_sstat = 1;
    rp_found = PMFALSE;

    do {
	if (!SetMem(act.recover.skip, token->code)) {
	    acceptbl(token->code, stack, *stack_p, token, &rp_found, point);
	}/*if*/

	if (!rp_found) {
	    new_stkp = 0;
	    if (SetMem(act.recover.fiduc, token->code)) {
		new_stkp = backup(stack, *stack_p, token->code);
	    }/*if*/
	    if (new_stkp > 0) {
		rp_found = PMTRUE;
		*stack_p = new_stkp;
		point->r_state = stack[*stack_p];
		errdescr.method = BAK_REC;
	    } else 
	        delSym(token);
	}/*if*/
    } while (!rp_found);
}/*search()*/


/*----------------------------------------------------------------------------
 * reach - Use the continuation functions and insert symbols upto curr token.
 *----------------------------------------------------------------------------
 */
static void reach(
ParseStack stack,		/* INOUT current stack */
short *stack_p,			/* INOUT current stack pointer */	
Token *token,			/* INOUT current symbol */
REC_POI *point			/* IN recovery point descriptor */
)
{
    UByte2 state;		/* Current state */
    UByte1 cont_sym;		/* Continuation symbol */
    Token gen_symb;		/* Generated symbol */
    UByte1 action;		/* Current parser action */
    UByte2 arg;			/* Current prod/state */
    PmBoolean sepaAccept;	/* Separator accepted yet? */
    PmBoolean useSepa;		/* Use the separator now? */

    state = stack[*stack_p];
    gen_symb = *token;
    useSepa = PMFALSE;
    while (state != point->r_state) {
	if (point->r_sepa)
	    if (state == point->r_sstat) {
		/* Separator state reached, remember to use separator */
		cont_sym = act.recover.cont[state-StateMin].ssym;
		useSepa = PMTRUE;
	    } else cont_sym = act.recover.cont[state-StateMin].tsym;
	else cont_sym = act.recover.cont[state-StateMin].tsym;
	sepaAccept = PMFALSE;

	do {
	  actTbl(state, cont_sym, &action, &arg);
	  switch (action) {

	  case ERROR_ACT:
	    paAbort(token, TAB_ERR, SYS_SEV);
	    break;

	  case ACCEPT_ACT:
	    break;

	  case SHIFT_ACT:
	    sepaAccept = PMTRUE;
	    state = arg;
	    inSym(cont_sym, &gen_symb);
	    ePush(state, stack, stack_p);
	    pmSySt[*stack_p] = gen_symb;
	    break;

	  case SHIFTRED_ACT:
	    sepaAccept = PMTRUE;
	    inSym(cont_sym, &gen_symb);
	    ePush(state, stack, stack_p);
	    pmSySt[*stack_p] = gen_symb;
	    goto reduce;

	  case REDUCE_ACT:
	    reduce:
	    do {
		*stack_p = *stack_p - gto.rhsz[arg-ProdMin];
		pmPaSema(arg);
		gtoTbl(stack[*stack_p], gto.lhs[arg-ProdMin], &action, &arg);
		ePush(state, stack, stack_p);
	    } while (action != SHIFT_ACT);
	    state = arg;
	    stack[*stack_p] = state;
	  }/*switch*/
	} while (useSepa && !sepaAccept);
    }/*while*/
}/*reach()*/


/*----------------------------------------------------------------------------
 * global - Global error recovery
 *----------------------------------------------------------------------------
 */
static void multiple(
ParseStack err_stk,		/* INOUT current parse stack */
short *err_stkp,		/* INOUT current stack pointer */
Token *err_tok,		/* INOUT current token */
UByte2 *newstat		/* OUT state after recovery */	
)
{
    REC_POI  point;		/* Recovery point descriptor */

    search(err_stk, err_stkp, err_tok, &point);
    reach(err_stk, err_stkp, err_tok, &point);
    *newstat = err_stk[*err_stkp];
}/*multiple()*/


/*----------------------------------------------------------------------------
 * S I N G L E   R E C O V E R Y
 * -----------------------------
 *
 * The single recovery technique tries to REPAIR the error by finding the
 * least cost single symbol correction. One single symbol of:
 * - insertion
 * - deletion
 * - replacement
 * is concidered. The cost of the repair is the sum of the ADAPTION cost and
 * the MODIFICATION cost. The adaption cost indicates how well a correction
 * fits in the context. The modification cost is based on the
 * insertion/deletion cost given in the input. A correction is applied if
 * the cost is below a predefined threshold value.
 *----------------------------------------------------------------------------
 */

#define ShiftCost (PmCost)	/* The cost of shifting one symbol */
#define InfCost (ShiftCost * (PmLaMax)) /* Infinity */
#define Thresh (((PmLaMax) - 3) * ShiftCost) /* Acceptance cost */


/*----------------------------------------------------------------------------
 * readLa - Read tokens to the look-ahead buffer
 *----------------------------------------------------------------------------
 */
static void readLa(
Token *curtok			/* IN current token */
)
{
    int i;
    Token tokbuf;
    Token *token = &tokbuf;

    la_buff[0] = *curtok;
    *token = *curtok;
    for (i = la_ptr + 1; i <= la_end; i++) {
	/* Move old look_ahead to the beginning of the buffer */
	la_buff[i - la_ptr] = la_buff[i];
    }/*for*/
    la_end = la_end - la_ptr;
    la_ptr = -1;

    while ((la_buff[la_end].code != ENDMARK) && (la_end < PmLaMax)) {
	la_end++;
	do {
            

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else {
		token->code = scIndex[token->code];
	    }/*if*/
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
	    }/*if*/
	} while (token->code == ERR_SYM);
	la_buff[la_end] = *token;
    }/*while*/
}/*readLa()*/


/*----------------------------------------------------------------------------
 * rdLaSym - Fetches the i:th look-ahead symbol code from the look-ahead set
 *----------------------------------------------------------------------------
 */
static UByte1 rdLaSym(
char index			/* IN i:th look-ahead symbol */
)				/* RET token code */
{
    if (index > la_end) return(ENDMARK);
    else return(la_buff[(int)index].code);
}/*rdLaSym()*/


/*----------------------------------------------------------------------------
 * laParse - Continue the parsing process by reading tokens from the
 *	     look-ahead set. The parse is terminated when:
 *	     - out of read ahead
 *	     - a new error is encountered
 *	     Note! No semantic actions are carried out
 *----------------------------------------------------------------------------
 */
static void laParse(
UByte1 sym,			/* IN current terminal symbol */
char next_la,			/* IN index to next look-ahead symbol */
ParseStack stack,		/* IN parse stack */
short stack_p,			/* IN current stack pointer */
short *cost			/* OUT adaption cost */
)
{
    PmBoolean done ;		/* Terminator flag */
    char sh_cnt;		/* Number of shifted symbols */
    UByte2 state;		/* Current state number */
    UByte1 action;		/* Parser action */
    UByte2 arg; 		/* Parser argument */
    short i;			/* Loop index */
    ParseStack t_stk;		/* Temporary stack */

    /* Copy stack
     */
    for (i = 0; i <= stack_p; i++) t_stk[i] = stack[i];	

    done = PMFALSE;
    sh_cnt = 0;
    state = t_stk[stack_p];

    while (!done) {
	actTbl(state, sym, &action, &arg);
	
	switch (action) {

	case ERROR_ACT: 
	    done = PMTRUE;
	    break;

	case SHIFT_ACT:
	    state = arg;
	    ePush(state, t_stk, &stack_p);
	    sh_cnt++;
	    if (sh_cnt == PmLaMax) done = PMTRUE;
	    else {
		sym = rdLaSym(next_la);
		next_la++;
	    }/*if*/
	    break;

	case SHIFTRED_ACT:
	    ePush(state, t_stk, &stack_p);
	    sh_cnt++;
	    if (sh_cnt == PmLaMax) done = PMTRUE;
	    else {
		sym = rdLaSym(next_la);
		if (next_la < PmLaMax) next_la++;
	    }/*if*/
	    goto reduce;

	case REDUCE_ACT:
	  reduce:
	    do {
		stack_p -= gto.rhsz[arg-ProdMin];
		gtoTbl(t_stk[stack_p], gto.lhs[arg-ProdMin], &action, &arg);
		ePush(state, t_stk, &stack_p);
	    } while (action != SHIFT_ACT); 

	    state = arg;
	    t_stk[stack_p] = state;
	    break;

	case ACCEPT_ACT:
	    done = PMTRUE;
	    sh_cnt = PmLaMax;
	    break;

	}/*switch*/
    }/*while*/

    *cost = InfCost - (sh_cnt*ShiftCost);
}/*laParse()*/


/*----------------------------------------------------------------------------
 * tryIn - Tries to insert a symbol from the legal set in front of current
 *	   token: x t y  => x st y, where s becomes current symbol
 *----------------------------------------------------------------------------
 */
static void tryIn(
TermSet legals,			/* IN set of legal symbols */
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
UByte1 *sym,			/* OUT best insertion symbol */
short *cost,			/* OUT best cost so far */
short *choice			/* OUT best choice so far */
)
{
    short i;
    short mod_cost;		/* Modification cost */
    short ad_cost;		/* Adaption cost */
    short tot_cost;		/* Total insertion cost */

    for (i = 1; i <= Terms; i++) {
	/* For all legal symbols
	 */
	if (SetMem(legals, i)) {
	    mod_cost = voc[i - TermMin].iCost;
	    if (mod_cost < *cost) {
		laParse(i, 0, stack, stack_p, &ad_cost);
		tot_cost = ad_cost + mod_cost;
		if (tot_cost < *cost) {
		    *cost = tot_cost;
		    *choice = IN_REC;
		    *sym = (UByte1)i;
		}/*if*/
	    }/*if*/
	}/*if*/
    }/*for*/
}/*tryIn()*/


/*----------------------------------------------------------------------------
 * tryRep - Tries to replace currrent symbol with a new terminal:
 *	    x t y  => x s y, where s becomes current symbol
 *----------------------------------------------------------------------------
 */
static void tryRep(
TermSet legals,			/* IN set of legal symbols */
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
UByte1 *sym,			/* OUT best replacement symbol */
short *cost,			/* OUT best cost so far */
short *choice			/* OUT best choice so far */
)
{
    short i;
    short mod_cost;		/* Modification cost */
    short ad_cost;		/* Adaption cost */
    short tot_cost;		/* Total replacment cost */

    for (i = 1; i <= Terms; i++) {
	/* For all legal symbols
	 */
	if (SetMem(legals, i)) {
	    mod_cost = (short) (voc[i-TermMin].iCost +
			voc[rdLaSym(0)-TermMin].dCost) / 2 + 1;
	    if (mod_cost < *cost) {
		laParse(i, 1, stack, stack_p, &ad_cost);
		tot_cost = ad_cost + mod_cost;
		if (tot_cost < *cost) {
		    *cost = tot_cost;
		    *choice = REP_REC;
		    *sym = (UByte1)i;
		}/*if*/
	    }/*if*/
	}/*if*/
    }/*for*/
}/*tryRep()*/


/*----------------------------------------------------------------------------
 * tryDel - Tries to delete current symbol: x t y  => x y
 *----------------------------------------------------------------------------
 */
static void tryDel(
ParseStack stack,		/* IN current parser stack */
short stack_p,			/* IN current stack pointer */
short *cost,			/* INOUT best cost so far */
short *choice			/* INOUT best choice so far */
)
{
    short mod_cost;		/* Modification cost */
    short ad_cost;  		/* Adaption cost */
    short tot_cost;		/* Total deletion cost */

    mod_cost = voc[rdLaSym(0) - TermMin].dCost;
    if (mod_cost < *cost) {
	laParse(rdLaSym(1), 2, stack, stack_p, &ad_cost);
	tot_cost = ad_cost + mod_cost;
	if (tot_cost < *cost) {
	    *cost = tot_cost;
	    *choice = DEL_REC;
	}/*if*/
    }/*if*/
}/*tryDel()*/


/*----------------------------------------------------------------------------
 * _pmInsert
 *----------------------------------------------------------------------------
 */
static void _pmInsert(
UByte1 sym,			/* IN symbol code to insert */
Token *token			/* OUT constructed token */
)
{
    inSym(sym, token);
}/*_pmInsert()*/


/*----------------------------------------------------------------------------
 * _pmReplace
 *----------------------------------------------------------------------------
 */
static void _pmReplace(
UByte1 sym,			/* IN replacement symbol code */
Token *token			/* OUT constructed token */
)
{
    delSym(token);
    inSym(sym, token);
}/*_pmReplace()*/


/*----------------------------------------------------------------------------
 * _pmDelete
 *----------------------------------------------------------------------------
 */

static void _pmDelete(
Token *token			/* OUT new token */
)
{
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    delSym(token);
}/*_pmDelete()*/


/*----------------------------------------------------------------------------
 * single - Single error recovery
 *----------------------------------------------------------------------------
 */
static void single(
TermSet leg_sys,		/* IN legal symbols in current state */
ParseStack err_stk,		/* INOUT current parser stack */
short *err_stkp,		/* INOUT current stack pointer */
Token *token,		/* INOUT current token */
UByte2 *newstat		/* OUT recovery state */
)
{
    short choice;		/* Recovery action performed */
    short cost;			/* Best cost so far */
    UByte1 sym;			/* Insert symbol */

    choice = NONE_REC;
    cost = InfCost;
    readLa(token);

    tryIn(leg_sys, err_stk, *err_stkp, &sym, &cost, &choice);
    tryRep(leg_sys, err_stk, *err_stkp, &sym, &cost, &choice);
    tryDel(err_stk, *err_stkp, &cost, &choice);

    if (cost > Thresh) choice = NONE_REC;

    switch (choice) {

    case IN_REC:
	_pmInsert(sym, token);
	break;

    case DEL_REC:  
	_pmDelete(token);
	break;

    case REP_REC: 
	_pmReplace(sym, token);
	break;

    default:
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    }/*switch*/

    *newstat = err_stk[*err_stkp];
}/*single()*/



/*----------------------------------------------------------------------------
 * recover - From an error
 *----------------------------------------------------------------------------
 */
static void recover(
ParseStack err_stk,		/* INOUT updated parse stack */
short *err_stkp,		/* INOUT updated stack pointer */
Token *err_symb,		/* INOUT current token */
UByte2 *rec_stat		/* OUT state after recovery */
)
{
    TermSet legal_sy;		/* Legal symbols */

    errdescr.err_tok = *err_symb;
    errdescr.err_tok.code = voc[errdescr.err_tok.code - TermMin].scc;
    errdescr.method = NONE_REC;
    errdescr.eClass = SYN_ERR;
    errdescr.severity = ERR_SEV;
    gLegSym(err_stk, *err_stkp, legal_sy);
    single(legal_sy, err_stk, err_stkp, err_symb, rec_stat);
    if (errdescr.method == NONE_REC) {
	multiple(err_stk, err_stkp, err_symb, rec_stat);
	pmMess(&errdescr.err_tok, errdescr.method, errdescr.eClass, 
	       errdescr.severity); 
    } else {
	pmMess(&errdescr.err_tok, errdescr.method, SYN_ERR, errdescr.severity);
    }/*if*/
    errdescr.res_tok = *err_symb;
    errdescr.res_tok.code = voc[errdescr.res_tok.code - TermMin].scc;
    pmRPoi(&errdescr.res_tok);
}/*recover()*/


/*----------------------------------------------------------------------------
 * pmParse - Parser routine, entry point
 *----------------------------------------------------------------------------
 */
void pmParse(void)
{
    paInit();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
    pushStatTok()
    if (setjmp(pmJmpB)) return;

    while (!endparse) {
	actTbl(currstat, token->code, &action, &arg);

	switch (action) {

	case ERROR_ACT:
	    recover(parsStk, &pmStkP, token, &currstat);
	    if (pmStkP == 0) endparse = PMTRUE;
	    break;

	case SHIFT_ACT:
	    currstat = arg;
	    pushStatTok();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
	    break;

	case SHIFTRED_ACT:
	    pushStatTok();
{
    if (la_ptr < la_end) {
	la_ptr++;
	*token = la_buff[la_ptr];
    } else {
	do {
	    

    smScan(lexContext, token);



	    if (token->code > SccMax || token->code < 0) {
		token->code = ERR_SYM;
	    } else token->code = scIndex[token->code];
	    if (token->code == ERR_SYM) {
		pmMess(token, DEL_REC, LEX_ERR, FAT_SEV);
		}
	} while (token->code == ERR_SYM);
    }
}
	    goto reduce;

 	case REDUCE_ACT:
	  reduce:
	    do {
		pmStkP -= gto.rhsz[arg - ProdMin];	
		pmPaSema(arg);
		gtoTbl(parsStk[pmStkP], gto.lhs[arg - ProdMin], &action, &arg);
		pushStat();
	    } while (action != SHIFT_ACT);

	    currstat = arg;
	    parsStk[pmStkP] = currstat;
	    break;

	case ACCEPT_ACT:
	    endparse = PMTRUE;
	    break;
	}/*switch*/
    }/*while*/
}/*pmParse()*/

